function outLine=GHF_SmChCirArc(Xc,Yc,Radius,AngleStart,AngleEnd,myLineColor,myLineStyle,myLineWidth)
% CIRCULARC Draw Circular Arc Using Line Object.
% Usage:		Hl=CIRCULARC(ARC) 
%		draws a circular arc in a counterclockwise direction on the current axes 
%		where ARC = Xc Yc Radius AngleStart AngleStart is a data set
%		containing the x- and y- coordinates of the arc center in Xc and Yc,
%		the radius of the arc in Ra, the starting angle in AngleStart, and the ending
%		angle in AngleEnd in RAD.
% 	GHF_SmChCirArc(x,y,Radius,WinkelStart, WinkelEnde,Farbe,Linienart,Liniendicke)
% Example:      GHF_SmChCirArc(0,0,1,1e-2,2*pi,'m','-',2) for a full Circle
% Author:       Olexandr Lednytskyy - (05-06-2008)

% theta=rem([AngleStart AngleEnd],2*pi); % wrap angles into one circle
% idx=find(theta<0);
% theta(idx)=theta(idx)+2*pi; % make angles positive, 0 to 2pi

if AngleEnd<AngleStart
	AngleEnd=AngleEnd+2*pi;
end
np=max(ceil(abs(AngleEnd-AngleStart)*500/(2*pi)),2);
thp=linspace(AngleStart,AngleEnd,np);

xp=abs(Radius)*cos(thp)+Xc; % x axis points
yp=abs(Radius)*sin(thp)+Yc; % y axis points

% default values
if nargin<6
	myLineColor='m';
end
if nargin<7
	myLineStyle='-';
end
if nargin<8
	myLineWidth=1;
end

% plot line
myLine=line(xp,yp,'Color',myLineColor,'LineStyle',myLineStyle,'LineWidth',myLineWidth);
if nargout
	outLine=myLine;
end