clear all
clf % zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 1, Aufgabe 1

% AUFGABENSTELLUNG:
% Eine Quelle mit der Generatorimpedanz Zi=(50+j75)Ohm soll einen
% Verbraucher Zv=(250-j75)Ohm bei einer von Frequenz f=1MHz 
% mit meoglichst viel Energie versorgen.
% GEGEBEN:
Zi_gegeben=complex(50,75); % Ohm
Zv_gegeben=complex(250,-75); % Ohm

% Teilaufgabe b) 
% GESUCHT:
% Moegliche Loesungen im Z-Diagramm

Zref=25; % Ohm % Wahl des Normierungswiderstandes Zref
Zi=Zi_gegeben/Zref;
Zv=Zv_gegeben/Zref;
angleZv=atan(imag(Zv)/real(Zv));

% Transformationen in der komplexen Widerstands- und Leitwertebene mithilfe eines Kreises in der komplexen Ebene:
radius=1/2*real(Zv)/cos(angleZv)/cos(angleZv); % zwei Mal Kosinussatz zum Zeichnen der Kreislinie ?ber die Koordinaten von Zv
NOP=1000; % Genuegende Anzahl der Punkte fuer eine Linie des Kreises oder Segmentes
[circleX,circleY]=GHF_circlePoints(0,2*pi,radius,NOP);
plot(circleX,circleY,'-k');
hold on

% 2. Moeglichkeit: Transformation von Zi -> Zv*
% Vertikale von jX=0 bis Zv*
stem(real(Zv),-(imag(Zv)),'fill','--m') % Zv*
hold on
text('Interpreter','latex','String','$${Z_v}^{\star}$$',...
	'Position',[(1+1/20)*real(Zv) -(1+1/20)*imag(Zv)],...
	'FontSize',14); % Zv*
hold on
exakt=10e-3; % zum Vergleich der double-Werten; 
% wenn exakt kleiner gesetzt waeren, dann haette man keine Punkten auf Kreisen gefunden gehabt 
% und die ensprechende Konstruktion waere kaum moeglich
for i=1:NOP
	if abs(circleX(i)-real(Zi))<=exakt % findet einen Wert fuer circleX in der Naehe von real(Zi) auf dem Kreis, um weiter circleY handzuhaben
		angle_Lp=-2*angleZv; % Winkel fuer ein Segment 'angle_Lp' auf dem Kreis
		if circleY(i)<0 % in der Halbebene mit circleY(i)<0
            % Vertikale von jX=0 bis Ls auf dem Kreis
			stem(circleX(i),circleY(i),'-b') % L_S
			hold on
			text('Interpreter','latex','String','$$L_S$$',...
				'Position',[(1+1/20)*circleX(i) -(1-1/20)*circleY(i)],...
				'FontSize',14,'color','m'); % L_S
			hold on

			% fuer ein Segment um Zi von Zv nach unten: '-imag(Zi)'
			angle_Cp=2*atan(-imag(Zi)/(real(Zi)))+angleZv;
			[circleX_Cp,circleY_Cp] = GHF_circlePoints(angle_Cp,angle_Lp,radius,NOP);
			plot(circleX_Cp,circleY_Cp,'-b'); % C_P
			hold on
			text('Interpreter','latex','String','$$C_P$$',...
				'Position',[(1-1/5)*real(Zv) -(1+1/5)*imag(Zv)],...
				'FontSize',14,'color','m'); % C_P
			hold on
		else % circleY(i)>=0
            % Vertikale von jX=0 bis Cs, nicht bis auf Ls
			stem(circleX(i),circleY(i),'-m') % C_S
			hold on

			% fuer ein Segment um Zi von Zv nach oben: '+imag(Zi)'
			angle_Cs=2*atan(imag(Zi)/real(Zi))-angleZv;
			[circleX_Cs,circleY_Cs] = GHF_circlePoints(angle_Cs,angle_Lp,radius,NOP);
			plot(circleX_Cs,circleY_Cs,'-m'); % L_P
			hold on
			text('Interpreter','latex','String','$$L_P$$',...
				'Position',[(1+1/20)*real(Zv) -(1-1/5)*imag(Zv)],...
				'FontSize',14,'color','b'); % L_P
			hold on
        end

        % Vertikale von jX=0 bis Zi
		stem(circleX(i),imag(Zi),'fill','-b') % Zi
		text('Interpreter','latex','String','$$Z_i$$',...
			'Position',[(1+1/20)*real(Zi) (1+1/20)*imag(Zi)],...
			'FontSize',14); % Zi
		hold on
		text('Interpreter','latex','String','$$C_S$$',...
			'Position',[(1-1/2)*real(Zi) (1-1/5)*imag(Zi)],...
			'FontSize',14,'color','b'); % C_S
		hold on
	end
end

% Achsenbeschriftung
ReAxisString=['$$\frac{R}{' strcat(num2str(Zref),'\Omega') '}$$'];
xlabel(ReAxisString,'Interpreter','Latex');
ImAxisString=['$$\frac{jX}{' strcat(num2str(Zref),'\Omega') '}$$'];
ylabel(ImAxisString,'Interpreter','Latex');
axis square;
hold on

%{
%}
