clear all
clf % zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 1, Aufgabe 1

% AUFGABENSTELLUNG:
% Eine Quelle mit der Generatorimpedanz Zi=(50+j75)Ohm soll einen
% Verbraucher Zv=(250-j75)Ohm bei einer von Frequenz f=1MHz 
% mit meoglichst viel Energie versorgen.
% GEGEBEN:
Zi_gegeben=complex(50,75); % Ohm
Zv_gegeben=complex(250,-75); % Ohm

% Teilaufgabe b)
% GESUCHT:
% Moegliche Loesungen im Y-Diagramm (Konforme Abbildung Z -> Y)

Zref=25; % Ohm
% Konforme Abbildung Z -> Y: GHF_Skript, S.32, F.(3.2)
Yi_transformiert=real(Zi_gegeben)/(abs(Zi_gegeben)^2)+i*conj(imag(Zi_gegeben))/(abs(Zi_gegeben)^2);
Yv_transformiert=real(Zv_gegeben)/(abs(Zv_gegeben)^2)+i*conj(imag(Zv_gegeben))/(abs(Zv_gegeben)^2);
Yi=Yi_transformiert*Zref;
Yv=Yv_transformiert*Zref;
angleYi=atan(imag(Yi)/real(Yi));

% Transformationen in der komplexen Widerstands- und Leitwertebene mithilfe eines Kreises in der komplexen Ebene:
radius=1/2*real(Yi)/cos(angleYi)/cos(angleYi); % zwei Mal Kosinussatz zum Zeichnen der Kreislinie ?ber die Koordinaten von Yi
center=[radius,0]; % [X,Y]
NOP=1000; % Genuegende Anzahl der Punkte f?r eine Linie des Kreises oder Segmentes
[circleX,circleY]=GHF_circlePoints(0,2*pi,radius,NOP);
plot(circleX,circleY,'-k');
hold on

% 2. Moeglichkeit: Transformation von Yi -> Yv*
% Vertikale von jX=0 bis Yi
stem(real(Yi),-imag(Yi),'fill','--b') % Yi
hold on
text('Interpreter','latex','String','$$Y_i$$',...
	'Position',[(1+1/20)*real(Yi) -(1-1/20)*imag(Yi)],...
	'FontSize',14); % Yi
hold on
exakt=10e-4; % zum Vergleich der double-Werten; 
% wenn exakt kleiner gesetzt waeren, dann haette man keine Punkten auf Kreisen gefunden gehabt 
% und die ensprechende Konstruktion waere kaum moeglich
for i=1:NOP
	if abs(circleX(i)-real(Yv))<=exakt % findet einen Wert fuer circleX in der Naehe von real(Zi) auf dem Kreis, um weiter circleY handzuhaben
		angle_Lp=2*angleYi;
		if circleY(i)<0
            % Vertikale von jX=0 bis Zi*
			stem(circleX(i),-circleY(i),'-m') % C_P
			hold on
			text('Interpreter','latex','String','$$C_P$$',...
				'Position',[(1+1/20)*circleX(i) (1-1/20)*circleY(i)],...
				'FontSize',14,'color','b'); % C_P
			hold on

			text('Interpreter','latex','String','$$L_S$$',...
				'Position',[(1-1/5)*real(Yi) -(1-1/20)*imag(Yi)],...
				'FontSize',14,'color','b'); % L_S
			hold on
			% fuer ein Segment um Yi von Yv nach unten: '-imag(Yi)'
			angle_LsCp=(2*atan(-imag(Yi)/real(Yi))-1/3*angleYi);
			[circleX_Cs,circleY_Cs] = GHF_circlePoints(-angle_Lp,angle_LsCp,radius,NOP);
			plot(circleX_Cs,circleY_Cs,'-b'); % LsCp
			hold on
		else % circleY(i)>=0
            % Vertikale von jX=0 bis Zi*
			stem(circleX(i),-circleY(i),'-b') % L_P
			hold on

			% fuer ein Segment um Yi von Yv nach oben: '+imag(Yi)'
			angle_Cs=(atan(imag(Yi)/real(Yi))+4/3*angleYi);
			[circleX_Cs,circleY_Cs] = GHF_circlePoints(-angle_Lp,angle_Cs,radius,NOP);
			plot(circleX_Cs,circleY_Cs,'-m'); % C_S
			hold on
			text('Interpreter','latex','String','$$C_S$$',...
				'Position',[(1+1/2)*real(Yi) -(1-1/20)*imag(Yi)],...
				'FontSize',14,'color','m'); % C_S
			hold on
        end

        % Vertikale von jX=0 bis Yv*
		stem(circleX(i),imag(Yv),'fill','-m') % Yv*
		text('Interpreter','latex','String','$${Y_v}^{\star}$$',...
			'Position',[(1+1/20)*real(Yv) (1+1/20)*imag(Yv)],...
			'FontSize',14); % Yv*
		hold on
		text('Interpreter','latex','String','$$L_P$$',...
			'Position',[(1-1/2)*real(Yv) -(1-1/5)*imag(Yv)],...
			'FontSize',14,'color','m'); % L_P
		hold on
	end
end

% Achsenbeschriftung
xlabel('$$G Z_L$$','Interpreter','Latex');
ylabel('$$j B Z_L$$','Interpreter','Latex');
axis square;
hold on

%{
%}
