clear all
clf % zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, bungsblatt 1, Aufgabe 1

% Aufgabenstellung:
% Quelle: Generatorimpedanz Zi=(50+j75)Ohm, Frequenz f=1MHz
Zi_gegeben=complex(50,75); % Ohm
f=1e6;
w=2*pi*f;
% Verbraucher: Impedanz Zv=(250-j75)Ohm
Zv_gegeben=complex(250,-75); % Ohm

% Teilaufgabe c)
% Mgliche Lsungen im Z-Diagramm
% Wahl des Normierungswiderstandes Zref:
Zref=1; % Ohm
Zi=Zi_gegeben/Zref;
Zv=Zv_gegeben/Zref;
angleZv=atan(imag(Zv)/real(Zv));
% Aus der Teilaufgabe b) fr Konforme Abbildung Z -> Y
% bilde Reziproken: GHF_Skript, S.32, F.(3.2)
Yi_transformiert=real(Zi_gegeben)/(abs(Zi_gegeben)^2)+i*conj(imag(Zi_gegeben))/(abs(Zi_gegeben)^2);
Yi=Yi_transformiert*Zref;

% Transformationen in der komplexen Widerstands- und Leitwertebene mithilfe eines Kreises in der komplexen Ebene:
radiusZv=1/2*real(Zv)/cos(angleZv)/cos(angleZv); % zwei Mal Kosinussatz zum Zeichnen der Kreislinie ber die Koordinaten von Zv
NOP=5000; % Gengende Anzahl der Punkte fr eine Linie des Kreises oder Segmentes
[circleX_Zv, circleY_Zv]=GHF_circlePoints(0,2*pi,radiusZv,NOP);
plot(circleX_Zv,circleY_Zv,'-k');
hold on

% 1. Mglichkeit: Schaltung 1, Start bei Zv, Ziel bei Zi*
stem(real(Zv),imag(Zv),'fill','--b') % Zv
text('Interpreter','latex','String','$${Z_v}^{\star}$$',...
	'Position',[(1-1/10)*real(Zv) (1+1/20)*imag(Zv)],...
	'FontSize',14); % Zv
hold on
exakt=10e-2; % zum Vergleich der double-Werten; wenn exakt kleiner gesetzt wrde, dann wrden keine Punkten auf Kreisen gefunden und die ensprechende Konstrukion knnte kaum mglich sein
for i=1:NOP
	if abs(circleX_Zv(i)-real(Zi))<=exakt % findet einen Wert fr circleX in der Nhe von real(Zi) auf dem Kreis, um weiter circleY handzuhaben
		angleLp=2*angleZv;
		if circleY_Zv(i)>0
			stem(circleX_Zv(i),circleY_Zv(i),'fill','-m') % C_S
			text('Interpreter','latex','String','$$C_S$$',...
				'Position',[(1+1/10)*real(Zi) -(1-1/5)*imag(Zi)],...
				'FontSize',14,'color','m'); % C_S
			hold on

			% radiusBk=1/2*abs(Circle(i))/cos(angleCircleZv)
			radiusBk=((circleX_Zv(i))^2+(circleY_Zv(i))^2)^(1/2)/cos(atan(circleX_Zv(i)/circleY_Zv(i)))/2;
			[circleX_Bk,circleY_Bk] = GHF_circlePoints(-pi/2,pi/2,radiusBk,NOP);
			plot(circleX_Bk-radiusBk,circleY_Bk+radiusBk,'-b'); % Hilfskreis zum Zk
			hold on

			% Thaleskreis:
			plot([0 circleX_Zv(i)],[2*radiusBk circleY_Zv(i)]) % Hilfsstahl: radiusBk -> Zk
			hold on
			plot([0 circleX_Zv(i)],[0 circleY_Zv(i)]) % Hilfsstahl: UrsprungKS -> Zk
			text('Interpreter','latex','String','$$Z_K$$',...
				'Position',[(1+1/20)*circleX_Zv(i) (1+1/20)*circleY_Zv(i)],...
				'FontSize',14); % Z_K
			hold on

			% fr ein Segment um Zi von Zv nach oben: '+imag(Zi)'
			angleCs=2*atan(imag(Zi)/real(Zi))-angleZv; % L_P
			[circleX_Cs,circleY_Cs] = GHF_circlePoints(angleCs,angleLp,radiusZv,NOP);
			plot(circleX_Cs,circleY_Cs,'-m');
			text('Interpreter','latex','String','$$L_P$$',...
				'Position',[(1+1/10)*circleX_Zv(i) (1+1/5)*circleY_Zv(i)],...
				'FontSize',14,'color','m'); % L_P
			hold on
		end

		stem(circleX_Zv(i),-imag(Zi),'fill','-m') % Zi*
		text('Interpreter','latex','String','$${Z_i}^{\star}$$',...
			'Position',[(1+1/20)*real(Zi) -(1+1/20)*imag(Zi)],...
			'FontSize',14); % Zi*
		hold on

		plot(2*radiusZv,0,'o') % Zo
		text('Interpreter','latex','String','$$Z_0$$',...
			'Position',[2*radiusZv 1/10*radiusZv],...
			'FontSize',14); % Zo
		hold on

		plot([0 2*radiusZv],[0 2*radiusZv*(imag(Zv)/real(Zv))]) % Hilfsstahl: UrsprungKS -> Zv
		hold on

		stem(2*radiusZv,2*radiusZv*imag(Zv)/real(Zv),'-b') % deltaX
		deltaXString=['$$\frac{\triangle X}{' strcat(num2str(Zref),'\Omega') '}$$'];
		text('Interpreter','latex','String',deltaXString,...
			'Position',[2*radiusZv (1-1/10)*2*radiusZv*imag(Zv)/real(Zv)],...
			'FontSize',12); % deltaX
	end
end

% Hilfskreis zu deltaX wg. dem Erhalten der Kreislinien mit allen kleineren Radien kreisfrmig
angleZv=atan(imag(Zv)/real(Zv));
radiusDX=(radiusZv/sin(angleZv))/cos(angleZv)*(imag(Zv)/real(Zv));
[circleX_DX,circleY_DX]=GHF_circlePoints(0,2*pi,radiusDX,NOP);
plot(circleX_DX,circleY_DX,'-k');
hold on

% Achsenbeschriftung
ReAxisString=['$$\frac{R}{' strcat(num2str(Zref),'\Omega') '}$$'];
xlabel(ReAxisString,'Interpreter','Latex');
ImAxisString=['$$\frac{jX}{' strcat(num2str(Zref),'\Omega') '}$$'];
ylabel(ImAxisString,'Interpreter','Latex');
axis square;
hold on

% 1. Mglichkeit: Schaltung 1
% Lsung:
Bk=-1/(2*radiusBk)*1e3; % mS
sprintf('Lsung fr Bk: %3.3f mS',Bk)
deltaX=2*radiusZv*imag(Zv)/real(Zv); % Ohm
sprintf('Lsung fr deltaX: %3.3f Ohm',deltaX)
Zo=2*radiusZv; % Ohm
sprintf('Lsung fr Zo: %3.3f Ohm',Zo)
Bv=-deltaX/(Zo^2)*1e3; % mS
sprintf('Lsung fr Bv: %3.3f mS',Bv)
Lp=-1/(w*(Bk-Bv))*1e9; % muH
sprintf('Lsung fr Lp: %3.3f muH',Lp)

% Mgliche rechnerische Lsung (Kreis und Gerade zum Schnitt bringen):
% a) Mit Lp von Zv nach Zk auf G=const-Kreis: (Zv||jwLp)=Zk
Gv=real(Zv)/(abs(Zv)^2); % =Gv=real(Zv)/(real(Zv)*real(Zv)+imag(Zv)*imag(Zv)); % nach dem bungsblatt
GvInv=1/Gv;
Rk=real(Zi);
Xk=sqrt(Rk*(GvInv-Rk));
Zk=complex(Rk,Xk);

Lp=1/(w*(conj(imag(Zv))/(abs(Zv)^2)+imag(Zk)/(abs(Zk)^2)))*1e6; % muH
sprintf('Rechnerische Lsung fr Lp: %3.3f muH',Lp)

% b) Mit Cs von Zk nach Zi* auf R=const-Gerade: j(Xi*-Xk)=-j180
Cs=-1/(w*(-imag(Zi)-imag(Zk)))*1e12; % pF
sprintf('Rechnerische Lsung fr Cs: %3.3f pF',Cs)

%{
%}