clear all
clf % zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 1, Aufgabe 1

% AUFGABENSTELLUNG:
% Eine Quelle mit der Generatorimpedanz Zi=(50+j75)Ohm soll einen
% Verbraucher Zv=(250-j75)Ohm bei einer von Frequenz f=1MHz 
% mit meoglichst viel Energie versorgen.
% GEGEBEN:
Zi_gegeben=complex(50,75); % Ohm
Zv_gegeben=complex(250,-75); % Ohm
f=1e6; % Hz
w=2*pi*f; % Kreisfrequenz

% Teilaufgabe c)
% GESUCHT:
% Moegliche Loesungen im Z-Diagramm

% Wahl des Normierungswiderstandes Zref:
Zref=1; % Ohm
Zi=Zi_gegeben/Zref;
Zv=Zv_gegeben/Zref;
angleZv=atan(imag(Zv)/real(Zv));
% Aus der Teilaufgabe b) konforme Abbildung Z -> Y: GHF_Skript, S.32, F.(3.2)
Yi_transformiert=real(Zi_gegeben)/(abs(Zi_gegeben)^2)+i*conj(imag(Zi_gegeben))/(abs(Zi_gegeben)^2);
Yi=Yi_transformiert*Zref;

% Transformationen in der komplexen Widerstands- und Leitwertebene mithilfe eines Kreises in der komplexen Ebene:
radiusZv=1/2*real(Zv)/cos(angleZv)/cos(angleZv); % zwei Mal Kosinussatz zum Zeichnen der Kreislinie ueber die Koordinaten von Zv
NOP=5000; % Genuegende Anzahl der Punkte fuer eine Linie des Kreises oder Segmentes
[circleX_Zv, circleY_Zv]=GHF_circlePoints(0,2*pi,radiusZv,NOP);
plot(circleX_Zv,circleY_Zv,'-k');
hold on

% 1. Moeglichkeit: Schaltung 1, Start bei Zv, Ziel bei Zi*
% Vertikale von jX=0 bis Zv
stem(real(Zv),imag(Zv),'fill','--b') % Zv
text('Interpreter','latex','String','$${Z_v}^{\star}$$',...
	'Position',[(1-1/10)*real(Zv) (1+1/20)*imag(Zv)],...
	'FontSize',14); % Zv
hold on
exakt=10e-2; % zum Vergleich der double-Werten; 
% wenn exakt kleiner gesetzt waeren, dann haette man keine Punkten auf Kreisen gefunden gehabt 
% und die ensprechende Konstruktion waere kaum moeglich
for i=1:NOP
	if abs(circleX_Zv(i)-real(Zi))<=exakt % findet einen Wert f?r circleX in der N?he von real(Zi) auf dem Kreis, um weiter circleY handzuhaben
		angleZv_Lp=2*angleZv;
		if circleY_Zv(i)<0
            % Vertikale von jX=0 bis Zk fuer Ls
			stem(circleX_Zv(i),circleY_Zv(i),'-m') % L_S
			text('Interpreter','latex','String','$$L_S$$',...
				'Position',[(1-1/5)*circleX_Zv(i) (1-1/5)*circleY_Zv(i)],...
				'FontSize',14,'color','m'); % L_S
			hold on

			% radiusBk=1/2*abs(Circle(i))/cos(angleCircleZv)
			radiusBk=((circleX_Zv(i))^2+(circleY_Zv(i))^2)^(1/2)/cos(atan(circleX_Zv(i)/circleY_Zv(i)))/2;
			[circleX_Bk,circleY_Bk] = GHF_circlePoints(-pi/2,pi/2,radiusBk,NOP);
			plot(circleX_Bk-radiusBk,circleY_Bk-radiusBk,'-b'); % Hilfskreis zum Zk
			hold on

			% Thaleskreis:
			plot([0 circleX_Zv(i)],[-2*radiusBk circleY_Zv(i)]) % Hilfsstahl: radiusBk -> Zk
			hold on
			plot([0 circleX_Zv(i)],[0 circleY_Zv(i)]) % Hilfsstahl: UrsprungKS -> Zk
			text('Interpreter','latex','String','$$Z_K$$',...
				'Position',[(1+1/20)*circleX_Zv(i) (1+1/20)*circleY_Zv(i)],...
				'FontSize',14); % Z_K
			hold on

			Xk=circleX_Zv(i);
			sprintf('L?sung f?r Xk: %3.3f Ohm',Xk)

			% fuer ein Segment um Zi von Zv nach unten: '-imag(Zi)'
			angleZv_Cp=2*atan(-imag(Zi)/(real(Zi)))+angleZv; % C_P
			[circleX_Cp,circleY_Cp] = GHF_circlePoints(angleZv_Cp,angleZv_Lp,radiusZv,NOP);
			plot(circleX_Cp,circleY_Cp,'-m');
			text('Interpreter','latex','String','$$C_P$$',...
				'Position',[(1-1/10)*real(Zv) (1+1/5)*imag(Zv)],...
				'FontSize',14,'color','m'); % C_P
			hold on
        end

        % Vertikale von jX=0 bis Zi*
		stem(circleX_Zv(i),-imag(Zi),'fill','-b') % Zi*
		text('Interpreter','latex','String','$${Z_i}^{\star}$$',...
			'Position',[(1+1/20)*real(Zi) -(1+1/20)*imag(Zi)],...
			'FontSize',14); % Zi*
		hold on

		plot(2*radiusZv,0,'o') % Zo
		text('Interpreter','latex','String','$$Z_0$$',...
			'Position',[2*radiusZv 1/10*radiusZv],...
			'FontSize',14); % Zo
		hold on

		plot([0 2*radiusZv],[0 imag(Zv)/real(Zv)*2*radiusZv]) % Hilfsstahl: UrsprungKS -> Zv
		hold on

        % Vertikale von jX=0 bis deltaX auf dem ausseren Kreis
		stem(2*radiusZv,2*radiusZv*imag(Zv)/real(Zv),'-b') % deltaX
		deltaXString=['$$\frac{\triangle X}{' strcat(num2str(Zref),'\Omega') '}$$'];
		text('Interpreter','latex','String',deltaXString,...
			'Position',[2*radiusZv (1-1/10)*2*radiusZv*imag(Zv)/real(Zv)],...
			'FontSize',12); % deltaX
	end
end

% Hilfskreis zu deltaX wg. dem Erhalten der Kreislinien mit allen kleineren Radien kreisf?rmig
angleZv=atan(imag(Zv)/real(Zv));
radiusDX=(radiusZv/sin(angleZv))/cos(angleZv)*(imag(Zv)/real(Zv));
[circleX_DX,circleY_DX]=GHF_circlePoints(0,2*pi,radiusDX,NOP);
plot(circleX_DX,circleY_DX,'-k');
hold on

% Achsenbeschriftung
ReAxisString=['$$\frac{R}{' strcat(num2str(Zref),'\Omega') '}$$'];
xlabel(ReAxisString,'Interpreter','Latex');
ImAxisString=['$$\frac{jX}{' strcat(num2str(Zref),'\Omega') '}$$'];
ylabel(ImAxisString,'Interpreter','Latex');
axis square;
hold on

% 1. Moeglichkeit: Schaltung 2
% Loesung:
Bk=1/(2*radiusBk)*1e3; % mS
sprintf('L?sung f?r Bk: %3.3f mS',Bk)
deltaX=2*radiusZv*imag(Zv)/real(Zv); % Ohm
sprintf('L?sung f?r deltaX: %3.3f Ohm',deltaX)
Zo=2*radiusZv; % Ohm
sprintf('L?sung f?r Zo: %3.3f Ohm',Zo)
Bv=-deltaX/(Zo^2)*1e3; % mS
sprintf('L?sung f?r Bv: %3.3f mS',Bv)
Cp=(Bk-Bv)/w*1e6; % nF
sprintf('L?sung f?r Cp: %3.3f nF',Cp)
Ls=(conj(imag(Zi))-Xk)/w*1e6; % muH
sprintf('L?sung f?r Ls: %3.3f muH',Ls)

% Moegliche rechnerische L?sung (Kreis und Gerade zum Schnitt bringen):
% 2. Moeglichkeit: Schaltung 2
% c) Mit Ls von Zi nach Zk auf R=const-Gerade: j(Xk-Xi)=jwLs
Gv=real(Zv)/(real(Zv)*real(Zv)+imag(Zv)*imag(Zv));
GvInv=1/Gv;
Rk=real(Zi);
Xk=sqrt(Rk*(GvInv-Rk));
Zk=complex(Rk,Xk);

Lp=(imag(Zk)-imag(Zi))/w*1e6; % muH
sprintf('Rechnerische L?sung f?r Ls: %3.3f muH',Lp)

% d) Mit Cp von Zk nach Zv* auf G=const-Kreis: (Zk||1/(jwCp))=Zv*
Cs=( imag(Zv)/(abs(Zv)^2) + imag(Zk)/(abs(Zk)^2) )/w*1e9; % nF
sprintf('Rechnerische L?sung f?r Cp: %3.3f nF',Cs)

%{
%}