clear all
clf % zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 1, Aufgabe 2

% AUFGABENSTELLUNG:
% Gegeben ist die Schaltung auf dem Aufgabenblatt. 
% Ermitteln Sie die Werte der Bauelemente C und L fuer Anpassung.
% GEGEBEN:
Zg=50; % Ohm % Generatorimpedanz
f=1e7; % Hz % Frequenz f=10MHz
w=2*pi*f; % Kreisfrequenz
C1=820*1e-12; % F
% Zi = Zg || 1/(jwC1)
Zi=complex(6.5,-17);
% Verbraucher: Widerstand Rv=20 Ohm
Rv=20; % Ohm
Cv=1.2*1e-9; % F
Zv=complex(Rv,-1/(w*Cv));
% GESUCHT: C und L fuer Anpassung.

% Wahl des Normierungswiderstandes Zref:
Zref=1; % Ohm
Zg=Zg/Zref;

% Transformationen in der komplexen Widerstands- und Leitwertebene mithilfe eines Kreises in der komplexen Ebene:
angleZv=atan(imag(Zv)/real(Zv));
radiusZv=1/2*real(Zv)/cos(angleZv)/cos(angleZv);
NOP=5000; % Genuegende Anzahl der Punkte fuer eine Linie des Kreises oder Segmentes
[circleX_Zv,circleY_Zv]=GHF_circlePoints(0,2*pi,radiusZv,NOP);
plot(circleX_Zv,circleY_Zv,'-k');
hold on

% 2. Moeglichkeit: Schaltung 2, Start bei Zv, Ziel bei Zi*
% Vertikale von jX=0 bis Zv
stem(real(Zv),imag(Zv),'fill','--b') % Zv
text('Interpreter','latex','String','$$Z_v$$',...
	'Position',[(1+1/10)*real(Zv) (1-1/10)*imag(Zv)],...
	'FontSize',14); % Zv
hold on

xOZv=0:1:real(Zv);
yOZv=imag(Zv)/real(Zv)*xOZv;
plot(xOZv,yOZv) % Hilfsstahl: UrsprungKS -> Zv
hold on

exakt=10e-3; % zum Vergleich der double-Werten; 
% wenn exakt kleiner gesetzt waeren, dann haette man keine Punkten auf Kreisen gefunden gehabt 
% und die ensprechende Konstruktion waere kaum moeglich
for i=1:NOP % Zeichne L & C und finde jX von Zv (=jX von Zk), zeichne den Weg fuer C
	if abs(circleX_Zv(i)-real(Zv))<=exakt % findet einen Wert fuer circleX in der Naehe von real(Zv) auf dem Kreis, um weiter circleY handzuhaben
		if circleY_Zv(i)<0
			% Thalesdreieck zu Zv: radiusBk=1/2*abs(Circle(i))/cos(angleCircleZv)
			radiusBv=((circleX_Zv(i))^2+(circleY_Zv(i))^2)^(1/2)/cos(atan(circleX_Zv(i)/circleY_Zv(i)))/2;
			% Strahl ([x0 x1],[y0 y1]): radiusBv -> Zv
			plot([0 circleX_Zv(i)],[-2*radiusBv circleY_Zv(i)])
			hold on

			angle_C=2*atan(circleY_Zv(i)/real(Zi)); % C
			angle_L=2*angleZv; % L
			[circleX_Zv_C,circleY_Zv_C] = GHF_circlePoints(angle_L,angle_C,radiusZv,NOP);
			plot(circleX_Zv_C,circleY_Zv_C,'-m');

			text('Interpreter','latex','String','$$C$$',...
				'Position',[(1-1/10)*real(Zv) (1+1/5)*imag(Zv)],...
				'FontSize',14,'color','m'); % C
			hold on
		end
	end
end
for i=1:NOP % aus jX von Zk finde R von Zi*, zeichne das Uebrige
	if abs(circleX_Zv(i)-real(Zi))<=exakt
		if circleY_Zv(i)<0
			% Thalesdreieck zu Zk
			radiusBk=((circleX_Zv(i))^2+(circleY_Zv(i))^2)^(1/2)/cos(atan(circleX_Zv(i)/circleY_Zv(i)))/2;
			% Strahl ([x0 x1],[y0 y1]): radiusBk -> Zk
			plot([0 circleX_Zv(i)],[-2*radiusBk circleY_Zv(i)])
			hold on
			% Strahl ([x0 x1],[y0 y1]): UrsprungKS -> Zk
			plot([0 real(Zv)],[0 circleY_Zv(i)/circleX_Zv(i)*real(Zv)])
			text('Interpreter','latex','String','$$Z_K$$',...
				'Position',[(1+1/20)*circleX_Zv(i) (1+1/20)*circleY_Zv(i)],...
				'FontSize',14); % Z_K
			hold on
            % Vertikale von jX=0 bis Zk
			stem(real(Zi),circleY_Zv(i),'-m') % Zk
			hold on

			% radiusBk=1/2*abs(Circle(i))/cos(angleCircleZi)
			radiusB1=((circleX_Zv(i))^2+(imag(Zi))^2)^(1/2)/cos(atan(circleX_Zv(i)/imag(Zi)))/2;
			[circleX_B1,circleY_B1] = GHF_circlePoints(-pi/2,pi/2,radiusB1,NOP);
			plot(circleX_B1-radiusB1,circleY_B1-radiusB1,'-b'); % Hilfskreis zum Z1
			hold on

			% Strahl ([x0 x1],[y0 y1])
			plot([real(Zv) real(Zv)],[imag(Zv) real(Zv)*circleY_Zv(i)/circleX_Zv(i)],'color','b') % deltaX
			deltaXString=['$$\frac{\triangle X}{' strcat(num2str(Zref),'\Omega') '}$$'];
			text('Interpreter','latex','String',deltaXString,...
				'Position',[real(Zv) (1-1/10)*real(Zv)*circleY_Zv(i)/circleX_Zv(i)],...
				'FontSize',12); % deltaX

			% Hilfskreis zu deltaX wg. dem Erhalten der Kreislinien mit allen kleineren Radien kreisfoermig
			angleDX=atan(real(Zv)*circleY_Zv(i)/circleX_Zv(i)/real(Zv));
			radiusDX=1/2*real(Zv)/cos(angleDX)/cos(angleDX);
			[circleX_DX, circleY_DX]=GHF_circlePoints(0,2*pi,radiusDX,NOP);
			plot(circleX_DX,circleY_DX,'-k');
			hold on

			L=((-imag(Zi))-circleY_Zv(i))/w*1e9; % nH
			sprintf('Loesung fuer L: %3.3f nH',L)
			C=-(1/(2*radiusBv)-1/(2*radiusBk))/w*1e12; % pF
			sprintf('Loesung fuer C: %3.3f pF',C)
		end
	end
end

% Hilfskreis zu Zi wg. dem Erhalten der Kreislinien mit allen kleineren Radien kreisfoermig
angleZi=atan(imag(Zi)/real(Zi));
radiusZi=1/2*real(Zi)/cos(angleZi)/cos(angleZi);
[circleX_Zi, circleY_Zi]=GHF_circlePoints(0,2*pi,radiusZi,NOP);
plot(circleX_Zi,circleY_Zi,'-k');
hold on

% Vertikale von jX=0 bis Zi*
stem(real(Zi),-imag(Zi),'fill','-m') % Zi*
text('Interpreter','latex','String','$${Z_i}^{\star}$$',...
	'Position',[(1+1/20)*real(Zi) -(1+1/20)*imag(Zi)],...
	'FontSize',14); % Zi*
hold on
text('Interpreter','latex','String','$$L$$',...
	'Position',[(1+1/10)*real(Zi) -(1-1/5)*imag(Zi)],...
	'FontSize',14,'color','m'); % L
plot(real(Zi),imag(Zi),'o') % Zi
text('Interpreter','latex','String','$$Z_i$$',...
	'Position',[(1+1/20)*real(Zi) (1+1/20)*imag(Zi)],...
	'FontSize',14); % Zi
hold on

% Achsenbeschriftung
ReAxisString=['$$\frac{R}{' strcat(num2str(Zref),'\Omega') '}$$'];
xlabel(ReAxisString,'Interpreter','Latex');
ImAxisString=['$$\frac{jX}{' strcat(num2str(Zref),'\Omega') '}$$'];
ylabel(ImAxisString,'Interpreter','Latex');
axis square;
hold on
