clear all
clf % zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 1, Aufgabe 3

% AUFGABENSTELLUNG:
% Ein Blindwiderstand Y=G+jB=(60-j40)mS soll durch die vorgegebene Schaltung transformiert werden
% GEGEBEN:
Y=complex(60,-40); % Ohm
% Teilaufgabe b)
C1=4.7*1e-9; % F
C2=3.3*1e-9; % F
f=1e6; % Hz
w=2*pi*f; % Kreisfrequenz
% GESUCHT: Bereich der Y-Ebene fuer Y'

% Transformationen in der komplexen Widerstands- und Leitwertebene mithilfe eines Kreises in der komplexen Ebene:
angleY=atan(imag(Y)/real(Y));
radiusY=1/2*real(Y)/cos(angleY)/cos(angleY);
NOP=1e3; % Anzahl der Punkte der Linie des Kreises
[circleX_Y, circleY_Y]=GHF_circlePoints(0,2*pi,radiusY,NOP);
plot(circleX_Y,circleY_Y,'-k');
hold on

% Vertikale von jX=0 bis Y
stem(real(Y),imag(Y),'fill','--b') % Y
text('Interpreter','latex','String','$$Y$$',...
	'Position',[(1-1/10)*real(Y) (1+1/20)*imag(Y)],...
	'FontSize',14); % Y
hold on

Go=2*radiusY; % Ohm
sprintf('Loesung fuer Go: %3.3f Ohm',Go)
deltaB=2*radiusY*imag(Y)/real(Y); % mS
sprintf('Loesung fuer deltaB: %3.3f mS',deltaB)
X=-deltaB/(Go^2)*1e3; % Ohm
sprintf('Loesung fuer X: %3.3f Ohm',X)
Xk=X-1/(w*C1);

% Hilfskreis zu Yk
diameterYk=(-1/Xk)*1e3; % mS
radiusYk=diameterYk/2; % mS

exakt=1e-2; % zum Vergleich der double-Werten; 
% wenn exakt kleiner gesetzt waeren, dann haette man keine Punkten auf Kreisen gefunden gehabt 
% und die ensprechende Konstruktion waere kaum moeglich
for i=1:NOP
	if abs(circleX_Y(i)-real(Y))<=exakt % findet einen Wert fuer circleX in der Naehe von real(Zv) auf dem Kreis, um weiter circleY handzuhaben
		plot(2*radiusY, 0, 'o') % Go
		text('Interpreter','latex','String','$$G_0$$',...
			'Position',[2*radiusY 1/10*radiusY],...
			'FontSize',14); % Go
		hold on

		plot([real(Y) 2*radiusY],[imag(Y) 0],'color','b') % Hilfsstahl: Y -> Go
		hold on
		plot([0 2*radiusY],[0 imag(Y)/real(Y)*2*radiusY],'color','b') % Hilfsstahl: UrsprungKS -> Y
		hold on

        % Vertikale von jX=0 bis deltaB auf dem ausseren Kreis
		stem(2*radiusY,2*radiusY*(imag(Y)/real(Y)),'-b') % deltaB
		text('Interpreter','latex','String','$$\triangle B$$',...
			'Position',[2*radiusY (1-1/10)*2*radiusY*imag(Y)/real(Y)],...
			'FontSize',12); % deltaB
		hold on
	end
	
	[circleX_Yk,circleY_Yk]=GHF_circlePoints(-pi/2,pi/2,radiusYk,NOP);
	plot(circleX_Yk-radiusYk,circleY_Yk+radiusYk,'-b'); % Hilfskreis zu Yk
	hold on

	if ((circleX_Yk(i)-2*radiusYk)<circleX_Y(i) || (circleX_Yk(i)-radiusYk)<circleX_Y(i)) && ((circleY_Yk(i)+radiusYk)>0)
		for j=1:NOP
			if (abs( (circleX_Y(i))-(circleX_Yk(j)-2*radiusYk) )<=exakt*10 || abs( (circleX_Y(i))-(circleX_Yk(j)-radiusYk) )<=exakt*10) && (abs( (circleY_Y(i))-(circleY_Yk(j)+radiusYk) )<=exakt*10)
				if (circleY_Y(i)>0)
					plot(circleX_Y(i),circleY_Y(i),'o','color','m') % Yk
					text('Interpreter','latex','String','$$Y_K$$',...
						'Position',[(1-1/10)*circleX_Y(i) (1-1/10)*circleY_Y(i)],...
						'FontSize',14,'color','k'); % Y_K
					hold on

					Bprim=(1/circleY_Y(i)+w*C2)*1e3;
					Yprim=complex(circleX_Y(i),Bprim); % mS
					sprintf('Rechnerische Loesung fuer Yprim: Yprim=%3.3f+j*(%3.3f) mS',real(Yprim),imag(Yprim))
					plot(circleX_Y(i),Bprim,'o','color','m') % Yprim
					hold on
					plot([circleX_Y(i) circleX_Y(i)],[circleY_Y(i) Bprim],'color','m') % C_2
					text('Interpreter','latex','String','$$C_2$$',...
						'Position',[(1+1/5)*circleX_Y(i) (1+1/2)*circleY_Y(i)],...
						'FontSize',14,'color','m'); % C_2
				end

				angleC1=2*angleY;
				angleC2=2*atan(circleY_Y(i)/circleX_Y(i)); % C_1
				[circleX_C1,circleY_C1] = GHF_circlePoints(angleC2,angleC1,radiusY,NOP);
				plot(circleX_C1,circleY_C1,'-m');
				text('Interpreter','latex','String','$$C_1$$',...
					'Position',[(1+1/5)*real(Y) (1-1/10)*imag(Y)],...
					'FontSize',14,'color','m'); % C_1
				hold on
			end
		end
	end
end

% Hilfskreis zu deltaB
angleY=atan(imag(Y)/real(Y));
radiusDB=(radiusY/sin(angleY))/cos(angleY)*(imag(Y)/real(Y));
[circleX_DB,circleY_DB]=GHF_circlePoints(0,2*pi,radiusDB,NOP);
plot(circleX_DB,circleY_DB,'-k');
hold on

% Achsenbeschriftung
xlabel('G/mS');
ylabel('jB/mS');
%axis square;
hold on
