clear all
clf % zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 1, Aufgabe 5

% AUFGABENSTELLUNG:
% Ein Widerstand R=1kOhm hat eine Serieninduktivitaet L1=159muH und eine Serienkapazitaet C1=1.59pF
% GEGEBEN:
R=1e3; % Ohm
L1=159*1e-6; %  H
C1=1.59*1e-12; %  F
% Teilaufgabe a)
% Kennzeichnen Sie auf der Ortskurven des komplexen Eingangswiderstandes und 
% des Eingangsleitwertes die Punkte, bei denen die Betriebsspannung f von der Resonnanzfrequenz f_r 
% um +/-0.1MHz; +/-0.2MHz; +/-0.5 MHz; +/- 1MHz abweicht.
% GEGEBEN:
dF=[0   0.1   -.1     0.2   -.2     0.5     -.5     1   -1]; % MHz % deltaF
% GESUCHT: Tabelle fuer Abweichungen

% Terme in der Gleichung fuer Z1
Xr=(L1/C1)^(1/2);
fr=(2*pi*((L1*C1)^(1/2)))^(-1);

% Initialisiere Felder fuer alle Frequenzen der Abweichungen
f(9)=0; fB(9)=0; XsB(9)=0; Xs(9)=0; G(9)=0; B(9)=0; Y(9)=0;
for i=1:length(dF)
	f(i)=dF(i)*1e6+fr; % Hz % Frequenz mit Abweichungen um die Resonanz
	fB(i)=f(i)/fr-fr/f(i); % w*sqrt(L1*C1)-1/(w*sqrt(L1*C1))
	XsB(i)=Xr*fB(i)/1e3; % gebe kOhm aus
	Xs(i)=XsB(i)*1e3; % rechne mit Ohm weiter
	G(i)=R/((Xs(i))^2+R^2)*1e3; % gebe kOhm aus
	B(i)=-Xs(i)/((Xs(i))^2+R^2)*1e3; % gebe kOhm aus
	% Y(i)=complex(G(i),B(i));
end

figU1A5a=figure('Position',[50 50 800 160]);
dataU1A5a=[
			{'dF1 / MHz' dF(1) dF(2) dF(3) dF(4) dF(5) dF(6) dF(7) dF(8) dF(9)};
			{'(f/fr-fr/f)' fB(1) fB(2) fB(3) fB(4) fB(5) fB(6) fB(7) fB(8) fB(9)};
			{'Xs / kOhm' XsB(1) XsB(2) XsB(3) XsB(4) XsB(5) XsB(6) XsB(7) XsB(8) XsB(9)};
			{'G, kOhm' G(1) G(2) G(3) G(4) G(5) G(6) G(7) G(8) G(9)};
			{'jB, kOhm' B(1) B(2) B(3) B(4) B(5) B(6) B(7) B(8) B(9)} 
		]
tableU1A5a=uitable('Data',dataU1A5a,'Parent',figU1A5a,'Position',[20 20 770 120]);
