clear all
close all
% zeichnet neu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 1, Aufgabe 5

% AUFGABENSTELLUNG:
% Ein Widerstand R=1kOhm hat eine Serieninduktivitaet L1=159muH und eine Serienkapazitaet C1=1.59pF
% GEGEBEN:
R=1e3; % Ohm
L1=159*1e-6; % H
C1=1.59*1e-12; % F

% Teilaufgabe b)
% Wie muss man zwei zusaetzliche Blindelemente schalten, um eine Kompensation 
% des Eingangswiderstandes in der Naehe der Resonanzfrequenz zu erreichen?
% Geben Sie die Groesse der Blindelemente an und zeichen Sie die Ortskurven 
% des komplexen Eingangswiderstandes und des Eingangsleitwertes!
% Markieren Sie die unter a) angegebenen Frequenzabweichungen!
% GESUCHT: Ortskurven von BG & XR

% Aus der Teilaufgabe a) werden Terme in der Gleichung fuer Z1 uebernommen:
Xr=(L1/C1)^(1/2);
Br=Xr/(R^2);
sprintf('Br=%3.3fmS',Br)
fr=(2*pi*((L1*C1)^(1/2)))^(-1);
Cp=Br/(2*pi*fr)*1e12;
sprintf('Cp=%3.3fpF',Cp)
Lp=1/(2*pi*fr*Br)*1e6;
sprintf('Lp=%3.3fmuH',Lp)

% Kompensation durch zwei zusaetzliche Blindelemente:
% stoerender Serienresonanzkreis -> Kompensation durch Parallelresonanzkreis: Y2=jBp+Y1
dF=[0 .1 -.1 .2 -.2 .5 -.5 1 -1]; % MHz % deltaF

% Initialisiere Felder fuer alle Frequenzen mit der Abweichungen
f(9)=0; fB(9)=0; F(9)=0; B(9)=0; Y2(9)=0;
for i=1:length(dF)
	f(i)=dF(i)*1e6+fr; % Hz % Frequenz mit Abweichungen um die Resonanz
	fB(i)=f(i)/fr-fr/f(i); % w*sqrt(L1*C1)-1/(w*sqrt(L1*C1))
	F(i)=Xr/R*fB(i); % eine beliebig waehlbare Funktion der Frequenz
	B(i)=Br*fB(i); % gebe kOhm aus
	Y2(i)=1e3/R*complex(1/(1+((F(i))^2)),((F(i))^3)/(1+((F(i))^2))); % gebe kOhm aus
end

figureU1A5b=figure('Position',[50 50 810 180]);
dataU1A5b=[
			{'dF1 / MHz' dF(1) dF(2) dF(3) dF(4) dF(5) dF(6) dF(7) dF(8) dF(9)};
			{'(f/fr-fr/f)' fB(1) fB(2) fB(3) fB(4) fB(5) fB(6) fB(7) fB(8) fB(9)};
			{'F(f)' F(1) F(2) F(3) F(4) F(5) F(6) F(7) F(8) F(9)}
			{'G, kOhm' real(Y2(1)) real(Y2(2)) real(Y2(3)) real(Y2(4)) real(Y2(5)) real(Y2(6)) real(Y2(7)) real(Y2(8)) real(Y2(9))};
			{'jB, kOhm' imag(Y2(1)) imag(Y2(2)) imag(Y2(3)) imag(Y2(4)) imag(Y2(5)) imag(Y2(6)) imag(Y2(7)) imag(Y2(8)) imag(Y2(9))}
			{'R / kOhm' real(1/Y2(1)) real(1/Y2(2)) real(1/Y2(3)) real(1/Y2(4)) real(1/Y2(5)) real(1/Y2(6)) real(1/Y2(7)) real(1/Y2(8)) real(1/Y2(9))};
			{'jX / kOhm' imag(1/Y2(1)) imag(1/Y2(2)) imag(1/Y2(3)) imag(1/Y2(4)) imag(1/Y2(5)) imag(1/Y2(6)) imag(1/Y2(7)) imag(1/Y2(8)) imag(1/Y2(9))}
		]
tableU1A5b=uitable('Data',dataU1A5b,'Parent',figureU1A5b,'Position',[20 20 770 140]);

% Zur graphischen Darstellung der Zissoide (xy-BG) und die Kardioide (xy-XR) 
% werden viele Frequenzwerte (NOP) und kleine Frequenzzuwachswerte (dFstep) benoetigt, 
% um glatte und konitnuierliche Kurven zu zeichnen
NOP=2000; % gerade
dFstep=.002;
dF(NOP)=0;
for i=3:NOP % Initialisiere das Feld dF mit abwechselden (+/-) Werten fuer zwei Halbebenen der Skizze
	if mod(i,2)==0 % even % gerade
		dF(i)=-dFstep+dF(i-2); % MHz
	else % odd
		dF(i)=+dFstep+dF(i-2); % MHz
	end
end

% Initialisiere Felder fuer alle Frequenzen mit der Abweichungen
f(9)=0; fB(9)=0; F(9)=0; B(9)=0; Y2(9)=0;
for i=1:length(dF)
	f(i)=dF(i)*1e6+fr;
	fB(i)=(f(i)/fr-fr/f(i));
	F(i)=Xr/R*fB(i);
	B(i)=Br*fB(i);
	Y2(i)=1e3/R*complex(1/(1+((F(i))^2)),((F(i))^3)/(1+((F(i))^2)));	
end

% Initialisiere Felder mit abwechselden (Re/Im) Werten fuer zwei Halbebenen der Skizze
dF(NOP)=0; xBG(NOP/2)=0; yBG(NOP/2)=0; xXR(NOP/2)=0; yXR(NOP/2)=0;
for i=1:NOP
	xBG(i)=real(Y2(i));
	yBG(i)=imag(Y2(i));	
	xXR(i)=real(1/Y2(i));
	yXR(i)=imag(1/Y2(i));	
end

% zum Zeichnen wird etwa Zeit gebraucht :-)
GHF_U1A5b_plotBG(xBG,yBG,length(dF)) % 
GHF_U1A5b_plotXR(xXR,yXR,length(dF))

