crefl
lear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 2, Aufgabe 1

% AUFGABENSTELLUNG:
% Durch einen Antennenverstaerker soll die Daempfung einer Antennenzuleitung ausgeglichen werden. 
% Von der Antennenzuleitung ist gegeben: 
% GEGEBEN: 
% Uebernahmefrequenz fu=70MHz
fu=70*1e6; % Hz
% Daempfungsbelag alpha(f=fu)=alphaFu=3*1e-3 m^(-1)
alphaFu=3*1e-3; % m^(-1)
% Laenge l=100m
l=100; % m
% Die Schaltung enthaelt keine Stossstellen! 
% Wieviel dB Verstaerung mu? der Verstaerker haben, damit die Leitungsdaempfung bei f=850MHz noch asgeglichen wird?
f=850*1e6; % Hz 
% GESUCHT:
% Daempfung D

% Bei einer schwach gedaempften Leitung gilt fuer die Leitungsdaempfung: alpha=1/2*alphaFu*(f/fu+sqrt(f/fu));
% Bestimmmung von alpha(850MHz):
alphaRprimFu=1/2*alphaFu; % bei f=fu
constRprim=alphaRprimFu/sqrt(fu); % in 1/(m*sqrt(Hz))
alphaRprim=constRprim*sqrt(f); % in 10^(-3) 1/m = 1/km
sprintf('alphaRprim bei 850 MHz: %3.3f*10^(-3) 1/m',alphaRprim*1e3)

alphaGprimFu=1/2*alphaFu; % bei f=fu
constGprim=alphaGprimFu/fu; % in 1/(m*sqrt(Hz))
alphaGprim=constGprim*f; % in 10^(-3) 1/m = 1/km
sprintf('alphaGprim(850MHz)=%3.3f*10^(-3) 1/m',alphaGprim*1e3) % Ausgabe von alphaGprim in 1/m

alphaGR=alphaGprim+alphaRprim; % in 10^(-3) 1/m = 1/km
sprintf('alphaGR(850MHz)=%3.3f*10^(-3) 1/m',alphaGR*1e3)
% Diese Loesung ist aequivalent zu:
alpha=1/2*alphaFu*(f/fu+sqrt(f/fu));
sprintf('Alpha bei 850 MHz: %3.3f*10^(-3) 1/m',alpha*1e3)

% Aequivalente Loesung fuer alphaGR auf dem Plot:
fa=1e-1:10:1e4; % initialisiere ein array von 0.1 bis 9.9901*10^3 mit dem Schritt 10
alphaRprim=1/2*(alphaFu*1e3)/sqrt(fu*1e-6)*sqrt(fa); % alphaRprim
alphaGprim=1/2*(alphaFu*1e3)/(fu*1e-6)*fa; % alphaGprim
alphaGR=alphaGprim+alphaRprim;
% Zeichne alpha gegen Frequenz fa auf der Skizze mit doppellogarithmischen Skalen:
loglog(fa,alphaRprim,'-r', fa,alphaGprim,'-m', fa,alphaGR,'-b'); hold on
% grid on % optionales Gitter auf der Skizze

% Zeichne alpha bei f=850 MHz mit der Skalierung der Frequenz-Achse in MHz-Einheiten: (alphaFu*1e-3)
alpha850=1/2*(alphaFu*1e3)*(f/fu+sqrt(f/fu));
plot((f*1e-6),alpha850,'or') % alpha(850MHz) wird als rotes Kreis 'or' dargestellt
% Eine Textmarke '\alpha(850MHz)' mithilfe des Latex-Editors auf der Skizze neben dem (roten) Kreis
text('Interpreter','latex','String','$$\alpha(850MHz)$$',...
	'Position',[(1-1/2)*(f*1e-6) (1+1/2)*alpha850],...
	'FontSize',14,'color','r'); % alpha(850MHz)
plot((fu*1e-6),(alphaFu*1e3),'om') % Auftragen von alphaFu: ein violettes Kreis
% Eine Textmarke '\alpha_u' mithilfe des Latex-Editors auf der Skizze neben dem (violetten) Kreis
text('Interpreter','latex','String','$$\alpha_u$$',...
	'Position',[(1-1/2)*(fu*1e-6) (1+1/2)*(alphaFu*1e3)],...
	'FontSize',14,'color','m'); % alphaFu

% Formatierung der Skizze mit Rahmen, Achsenbeschriftung, Legende
axis([1e-1 1e4 1e-2 1e3]) % axis([xmin xmax ymin ymax])
xlabel('f / MHz');
ylabel('\alpha*(10^{-3}m)');
legend('\alpha_{R''}','\alpha_{G''}','\alpha',3,'Location','NorthWest');

% Bestimmung der Leitungsdaempfung fuer eine in z-Richtung laufende Welle:
D=20*log10(exp(1))*alpha*100; % dB
sprintf('D?mpfung D=%3.3f dB',D)
