clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 2, Aufgabe 2

% AUFGABENSTELLUNG:
% Der Empf?nger-Eingangsleitwert Ye=(45+j75)mS soll mithilfe einer (50 Ohm)-Leitung der Laenge l und einer Spule 
% mit der Induktivitaet L bei der Kreisfrequenz w an 50Ohm angepasst wereden.
% GEGEBEN: 
Ye_gegeben=1e-3*(45+j*75); % in Sievert
ZL=50; % Ohm % Wellenwiderstand der transformierten (50 Ohm)-Leitung
Ze=50; % Ohm
% EINFACHE UMFORMUNG:
Ye=Ye_gegeben*ZL; % normiert auf ZL=50 Ohm
% Bestimmen Sie l/lambda und wL.
% GESUCHT:
% lDL als l/lambda und wL

% Smithdiagramm in der Leitwertform wegen der Leitungstransformation und Parallelschaltung
GHF_SmithChart(0,1); hold on

% Verwende equ 3.1 fuer r_Ye:
% Quelle fuer equ: http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
r_Ye=(1-Ye)/(1+Ye); % Reflexionsfaktor fuer Admittanz % Formel (5.29) im GHF_Skript
% Eine Textmarke 'Y_EZ_L' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$Y_EZ_L$$',...
	'Position',[(1-1/10)*real(r_Ye) (1+1/10)*imag(r_Ye)],...
	'FontSize',12,'color','m'); % Y_E*Z_L

% Radius auf der rechten Seite der Gleichung equ 3.12, verwende equ 3.4 fuer g:
Radius_re_r_Ye=1/(1+((1-real(r_Ye)^2-imag(r_Ye)^2)/((1+real(r_Ye))^2+imag(r_Ye)^2))); % equ 3.4 & 3.12
% Bestimme Mittelpunkte x, y auf dem m-Kreis von ~0Grad (=1e-2=0.01) bis 360Grad (=2*pi)
xC_re_r_Ye=Radius_re_r_Ye-1;
yC_re_r_Ye=0;
% GHF_SmChCirArc(x,y,winkelStart, WinkelEnde,Farbe,Linienart,Liniendicke)
GHF_SmChCirArc(xC_re_r_Ye,yC_re_r_Ye,Radius_re_r_Ye,1e-2,2*pi,'r','--',2);
% Eine Textmarke 'G_EZ_L' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String',strcat('$$G_EZ_L=$$',num2str(real(Ye))),...
	'Position',[(1-1/5)*real(r_Ye) (1-1/3)*imag(r_Ye)],...
	'FontSize',12,'color','r'); % G_E*Z_L

% Radius auf der rechten Seite der Gleichung equ 3.17, verwende equ 3.5 fuer b:
Radius_im_r_Ye=1/((-2*imag(r_Ye))/((1+real(r_Ye))^2+imag(r_Ye)^2)); % equ 3.17 & 3.5
% Bestimme Mittelpunkte x, y fuer einen Bogen (hier: Kreis) von ~0Grad (=1e-2=0.01) bis 360Grad (=2*pi)
xC_im_r_Ye=-1;
yC_im_r_Ye=-Radius_im_r_Ye;
GHF_SmChCirArc(xC_im_r_Ye,yC_im_r_Ye,Radius_im_r_Ye,1e-2,2*pi,'b','--',2);
% Eine Textmarke 'B_EZ_L' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String',strcat('$$B_EZ_L=$$',num2str(imag(Ye))),...
	'Position',[(1+1/5)*real(r_Ye) (1+1/3)*imag(r_Ye)],...
	'FontSize',12,'color','b'); % B_E*Z_L

% delta-Strahl mit der Angabe von dem Winkel Theta und des Verhaeltnisses Leitungslaenge/Wellenlaenge (hier: l/lambda)
[numlDL_r_Ye numTheta_r_Ye]=GHF_SmChRay([real(r_Ye) imag(r_Ye)],'b'); % GHF_SmChRay([x y],Strahlfarbe)

% Schnittpunkte der Kreise
[x1_r_Y1,y2_r_Y1]=circcirc(-1/2,0,1/2,0,0,abs(r_Ye)); % circcirc(x1,y1,r1,x2,y2,r2)
% Bedingungen fuer positive oder negative Punkte in bestimmten Kreisquadranten, 
% um die relevante (nach Theta und l/lambda) Schnittpunkte zu waehlen
if x1_r_Y1(1)<0 && y2_r_Y1(1)<0
	r_Y1=x1_r_Y1(1)+j*y2_r_Y1(1);
elseif x1_r_Y1(2)<0 && y2_r_Y1(2)<0
	r_Y1=x1_r_Y1(2)+j*y2_r_Y1(2);
else
	sprintf('Es gibt keine Schnittpunkte, bzw. keiner der Schnittpunkte liegt in der unteren Halbebene zwischen 180Grad und 270Grad, s.d. die Drehung auf m-Kreis im Uhrzeigersinn bis Schnitt mit dem (G*ZL=1)-Kreis den Punkt Y1ZL ergibt.')
	r_Y1=nan+j*nan;
end

% Eine Textmarke 'Y_1Z_L' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$Y_1Z_L$$',...
	'Position',[(1+1/10)*real(r_Y1) (1+1/10)*imag(r_Y1)],...
	'FontSize',12,'color','m'); % Y1ZL
Radius_GZL=1/2;
% Bestimme Mittelpunkte x, y f?r einen Bogen von angleCenterGZL_r_Y1 bis 0?
xC_GZL=-1/2;
yC_GZL=0;
angleCenterGZL_r_Y1=atan2(imag(r_Y1),real(r_Y1)-xC_GZL);
% Zum Vergleich von dem Winkel mit den unten ausgerechneten:
% angleCenterSmithChart_r_Y1=atan2(imag(r_Y1),real(r_Y1)); 
% Auftragen eines m-Kreises (magneta) und des roten delta-Strahles 
GHF_SmChCirArc(xC_GZL,yC_GZL,Radius_GZL,angleCenterGZL_r_Y1,0,'m','-',2); % G*ZL=1-Kreis

% Eine Textmarke 'B_1Z_L' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$B_1Z_L$$',...
	'Position',[(1+1/5)*real(r_Y1) (1+1/3)*imag(r_Y1)],...
	'FontSize',12,'color','b'); % B_1*Z_L
% Radius auf der rechten Seite der Gleichung equ 3.17, verwende equ 3.5 f?r b:
Radius_im_r_B1=1/((-2*imag(r_Y1))/((1+real(r_Y1))^2+imag(r_Y1)^2)); % equ 3.17 & 3.5
xC_im_r_B1=-1;
yC_im_r_B1=-Radius_im_r_B1;
GHF_SmChCirArc(xC_im_r_B1,yC_im_r_B1,Radius_im_r_B1,1e-2,2*pi,'b','--',2);

% delta-Strahl mit der Angabe von dem Winkel Theta und des Verh?ltnisses Leitungsl?nge/Wellenl?nge (hier: l/lambda)
[numlDL_r_Y1 numTheta_r_Y1]=GHF_SmChRay([real(r_Y1) imag(r_Y1)],'r');
Radius_r_YeY1=abs(r_Ye);
xC_r_YeY1=0;
yC_r_YeY1=0;
% Auftragen eines m-Kreises (magneta) und des blauen delta-Strahles
GHF_SmChCirArc(xC_r_YeY1,yC_r_YeY1,Radius_r_YeY1,numTheta_r_Y1*pi/180,numTheta_r_Ye*pi/180,'m','-',2);

% Leitungsl?nge/Wellenl?nge (hier: l/lambda)
lDL=(0.5-numlDL_r_Ye)+numlDL_r_Y1;
sprintf('lDL=%3.3f',lDL) % Ausgabe von lDL

Y1=(1-r_Y1)/(r_Y1+1); % Formel (5.33) im GHF_Skript
% ?ber die Defnition des komplexen Refexionsfaktors erh?lt man in der Leitwertsebene:
B1ZL=imag(Y1);
wL=ZL/B1ZL;
sprintf('wL=%2.2f Ohm',wL)
