clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, ?bungsblatt 2, Aufgabe 4

% AUFGABENSTELLUNG:
% Ein angepa?ter Generator speist obige Leitungskonfiguration mit einer Leistung P0. 
% ?ber zwei schwach verlustbehaftete Leitungen der L?ngen l1 und l2 wird ein reeller Verbraucher Rv angeschlossen. 
% An der Verbindung beider Leitungen ist ein kurzes St?ck verlustloser Leitung l3 parallel geschaltet.
% GEGEBEN: 
% Leitung 1
ZL1=50; % Ohm
alpha1=0.2; %  dB/m
% EINFACHE UMFORMUNG:
% Umrechnung von alpha [dB/m] in alpha [1/m] mittels des Faktors 8.69
alpha1=alpha1/8.69; % 1/m
% GEGEBEN: 
l1=30; % m
% Leitung 2
ZL2=150; % Ohm
alpha2=1.2; % dB/m
% EINFACHE UMFORMUNG:
alpha2=alpha2/8.69; % 1/m
% GEGEBEN: 
l2=2.5; % m
% Leitung 3
ZL3=25; % Ohm
alpha3=0; % dB/m
% EINFACHE UMFORMUNG:
alpha3=alpha3/8.69; % 1/m
% GEGEBEN: 
l3=.15; % m
% Hilfsgr??en
P0=1; % W
f=300*1e6; % Hz
% EINFACHE UMFORMUNG:
c_vac=3*1e8; %  m/s
lambda=c_vac/f; % m
% GESUCHT:
% deltaP1 in der Leitung 1
% deltaP2 in der Leitung 2
% die dem Verbraucher zugefuehrte Leistung PW
% VSWR (Voltage Standing Wave Ratio)

% Berechnung von |r1|:
beta=2*pi/lambda;
B3K=-cot(beta*l3)/ZL3; % Leitung 3 als Blindelement
G2=1/ZL2; %  da Leitung 2 angepasst ist 
Y1=1/ZL1*complex(G2*ZL2*ZL1/ZL2,B3K*ZL3*ZL1/ZL3); % Trafo und Parallelschalten
r1=(1-Y1*ZL1)/(1+Y1*ZL1);  % Reflexionsfaktor fuer Admittanz % Formel (5.29) im GHF_Skript
abs_r1=abs(r1); % |r1| aus dem Smith-Diagramm

% Teilaufgabe a) 
% Berechnen Sie die vom Verbraucher aufgenommene Wirkleistung Pw und die in den Leitungen 1 und 2 
% auftretenden Verlustleistungen P1 und P2.
P1H_l1=P0*exp(-2*alpha1*l1); % in der Leitung 1 auftretende Verlustleistung
P1R_l1=((abs(r1))^2)*P1H_l1; % an der Verzweigung reflektirte Leistung
deltaP1H=P0*(1-exp(-2*alpha1*l1)); % Verlustleistung der hinlaufenden Welle
deltaP1R=P1R_l1*(1-exp(-2*alpha1*l1)); % Verlustleistung der ruecklaufenden Welle
deltaP1=deltaP1H+deltaP1R; % in W
sprintf('deltaP1=%3.3f mW',deltaP1*1e3) % Ausgabe von deltaP1

P2H=(1-((abs(r1))^2))*P1H_l1; % In Leitung 2 auftretende Verlustleistung
PW=(1-((abs(r1))^2))*P0*exp(-2*alpha1*l1)*exp(-2*alpha2*l2); % dem Verbraucher zugefuehrte Leistung Pw
sprintf('PW=%3.3f mW',PW*1e3)
deltaP2=P0*(1-exp(-2*alpha2*l2))*(1-((abs(r1))^2))*exp(-2*alpha1*l1); % W
sprintf('deltaP2=%3.3f mW',deltaP2*1e3)

% Teilaufgabe b)
% Wie gross ist das Stehwellenverhaeltniss am Anfang der Leitung 1?
PR=P0-(PW+deltaP1+deltaP2);
abs_r_ein=sqrt(abs(PR/P0));
VSWR=(1+abs_r_ein)/(1-abs_r_ein); % Voltage Standing Wave Ratio
sprintf('VSWR=%3.3f',VSWR) % Ausgabe auf die MATLAB-Konsole
