clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 3, Aufgabe 1

% AUFGABENSTELLUNG:
% Welche Kurve durchlaeuft bei der Schaltung der Eingangsreflexionsfaktor r bezogen auf 50Ohm, 
% wenn die L?nge der Leitung von l=lambda/8 bis 3*lambda/8 durchgestimmt wird?
% GEGEBEN: 
Zref=50; % Ohm % Referenzwiderstand
Z_gegeben=Zref*complex(1,3); % Ohm % Lastwiderstand
ZL=100; % Ohm % Leitungswiderstand
% EINFACHE UMFORMUNG:
Z=Z_gegeben/ZL; % Normierung auf ZL
r_Z=(Z-1)/(Z+1); % Reflexionsfaktor 
% GESUCHT:
% m-Kreis auf der reellen Achse

% Smithdiagramm in der Widerstandsform
GHF_SmithChart(1,0); hold on
% Zeichne des Reflexionsfaktors auf dem Smithdiagramm
plot(real(r_Z),imag(r_Z),'m*'); hold on
% Eine Textmarke 'Z' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$Z$$',...
	'Position',[(1+1/20)*real(r_Z) (1+1/20)*imag(r_Z)],...
	'FontSize',12,'color','m'); % Z

% Zeichne Z' in die r'-Ebene
plot([0 real(r_Z)],[0 imag(r_Z)],'m--','LineWidth',2); % ([x1  x2],[y1  y2])
% Bestimme Mittelpunkte x, y fuer den m-Kreis von angleCenterGZL_r_Y1 bis 0Grad
RadiusZ=sqrt(real(r_Z)^2+imag(r_Z)^2);
% Zeichne ein voller m-Kreises
GHF_SmChCirArc(0,0,RadiusZ,1e-2,2*pi,'m','-',2);
% RL_100=(1-RadiusZ)/(1+RadiusZ); % behalte diese Rechnung fuer RL bei ZL=100, siehe GHF_Skript, Seite 84, Formel 5.35

% Zeichne ein violetter Punkt bei [RadiusZ,0]
plot(RadiusZ,0,'m*'); hold on
% Eine Textmarke 'R_R' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$R_R$$',...
	'Position',[(1+1/20)*RadiusZ (1+1/20)*0 ],...
	'FontSize',12,'color','m'); % RR

% Ermittle Z' ( l=lambda/8 )
% Berechne ThetaZL8 (=Winkel fuer l=lambda/8) gedreht um 90Grad von ThetaZ (=Winkel fuer r_Z)
ThetaZ=atan2(imag(r_Z),real(r_Z));
ThetaZL8=-(pi/2-ThetaZ);
% Berechne Punktkoordinaten von Z' ( l=lambda/8 )
reZL8=cos(ThetaZL8)*RadiusZ;
imZL8=sin(ThetaZL8)*RadiusZ;
% Zeichne ZL8 (magneta)
plot(reZL8,imZL8,'m*'); hold on
% Eine Textmarke 'Z(l=\lambda/8)' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$Z(l=\lambda/8)$$',...
	'Position',[(1-1/2)*reZL8 (1-1/5)*imZL8],...
	'FontSize',12,'color','m'); % ZL8
% Zeichne Z'(l=lambda/8) in die r'-Ebene
plot([0 reZL8],[0 imZL8],'m--','LineWidth',2); % ( [x1  x2] , [y1  y2] )

% Ermittle Z' ( l=3*lambda/8 )
plot(-RadiusZ,0,'m*'); hold on
text('Interpreter','latex','String','$$R_L$$',...
	'Position',[(1-1/20)*(-RadiusZ) (1+1/20)*0 ],...
	'FontSize',12,'color','m'); % RL
reZ3L8=-reZL8;
imZ3L8=-imZL8;
plot(reZ3L8,imZ3L8,'m*'); hold on
text('Interpreter','latex','String','$$Z(l=3\lambda/8)$$',...
	'Position',[(1-1/20)*reZ3L8 (1+1/5)*imZ3L8],...
	'FontSize',12,'color','m'); % Z3L8
% Zeichne Z'(l=3*lambda/8) in die r'-Ebene
plot([0 reZ3L8],[0 imZ3L8],'m--','LineWidth',2); % ( [x1  x2] , [y1  y2] )
