clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 3, Aufgabe 1

% AUFGABENSTELLUNG:
% Welche Kurve durchlaeuft bei der Schaltung der Eingangsreflexionsfaktor r bezogen auf 50Ohm, 
% wenn die Laenge der Leitung von l=lambda/8 bis 3*lambda/8 durchgestimmt wird?
% Benutze den Wert des Normierungswiderstandes ZL=100 Ohm aus der Teilaufgabe a)
% zur Bestimmung von mRL_100=RL~0.15*100 Ohm, um weiter auf mRL_50=RL~0.3*50 Ohm umzurechnen:

% Aus der Teilaufgabe a) werden folgende Werte uebernommen:
% GEGEBEN: 
Zref=50; % Ohm % Referenzwiderstand
Z_gegeben=Zref*complex(1,3); % Ohm % Lastwiderstand
ZL=100; % Ohm % Leitungswiderstand
% EINFACHE UMFORMUNG:
Z=Z_gegeben/ZL; % normiert
r_Z=(Z-1)/(Z+1); % Reflexionsfaktor % siehe GHF_Skript, Seite 57, Formel 4.27 
% Beschreibung der Rechenschritte siehe in der Datei GHF_U3A1a.m Teilaufgabe a)
ThetaZ=atan2(imag(r_Z),real(r_Z));
RadiusZ=sqrt(real(r_Z)^2+imag(r_Z)^2);
mRL_100=(1-RadiusZ)/(1+RadiusZ); % RL bei ZL=100, siehe GHF_Skript, Seite 84, Formel 5.35
ThetaZL8=-(pi/2-ThetaZ);
reZL8=cos(ThetaZL8)*RadiusZ;
imZL8=sin(ThetaZL8)*RadiusZ;
% Quelle fuer equ: http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
ZL8cross=(1+(reZL8+j*imZL8))/(1-(reZL8+j*imZL8)); % equ 2.4 % Schnittpunkt
reZ3L8=-reZL8;
imZ3L8=-imZL8;
Z3L8cross=(1+(reZ3L8+j*imZ3L8))/(1-(reZ3L8+j*imZ3L8)); % Schnittpunkt

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Teilaufgabe b)
% GEGEBEN: 
Zref=50; % Ohm % Referenzwiderstand
Z_gegeben=Zref*complex(1,3); % Ohm % Lastwiderstand
ZL=50; % Ohm % Leitungswiderstand
% EINFACHE UMFORMUNG:
Z=Z_gegeben/ZL; % normiert auf ZL
r_Z=(Z-1)/(Z+1); % Reflexionsfaktor % siehe GHF_Skript, Seite 57, Formel 4.27 
% GESUCHT:
% m-Kreis auf der reellen Achse bei _anderem_ Bezugswiderstand

GHF_SmithChart(1,0); hold on % Smithdiagramm in der Widerstandsform
% Auftragen des Reflexionsfaktors auf dem Smithdiagramm
plot(real(r_Z),imag(r_Z),'m*'); hold on
% Eine Textmarke 'Z' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$Z$$',...
	'Position',[(1+1/20)*real(r_Z) (1+1/20)*imag(r_Z)],...
	'FontSize',12,'color','m'); % Z
% ThetaZ=atan2(imag(r_Z),real(r_Z)); % in Polarkoordinaten % immer gut zu wissen

% Bestimme RL bei ZL=50: Abbildung aus der r'-Ebene in die r-Ebene
mRL_50=mRL_100*100/50;
sprintf('mRL_50=%3.3f*%3.3f Ohm',mRL_50,100) % Ausgabe von mRL_50 in Ohm
absRL_100=abs((1-mRL_100)/(1+mRL_100)); % m-Kreis bei ZL=100, siehe GHF_Skript, Seite 84, Formel 5.35
absRL_50=abs((1-mRL_50)/(1+mRL_50)); % m-Kreis bei ZL=50, siehe GHF_Skript, Seite 84, Formel 5.35
% Zeichne absRL_50 (magneta)
plot(-absRL_50,0,'m*'); hold on
% Eine Textmarke 'R_L' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$R_L$$',...
	'Position',[(1-1/20)*(-absRL_50) (1+1/20)*0 ],...
	'FontSize',12,'color','m'); % RL

% Bestimme und gebe abzubildene Punktenkoordinate in der komplexen Darstellung aus
ZL8_100=ZL8cross;
sprintf('ZL8_100 = %3.3f + j*(%3.3f)',real(ZL8_100),imag(ZL8_100))
Z3L8_100=Z3L8cross;
sprintf('Z3L8_100 = %3.3f + j*(%3.3f)',real(Z3L8_100),imag(Z3L8_100))
ZL8_50=ZL8_100*100/50; % normiert
sprintf('ZL8_50 = %3.3f + j*(%3.3f)',real(ZL8_50),imag(ZL8_50))
Z3L8_50=Z3L8_100*100/50; % normiert
sprintf('Z3L8_50 = %3.3f + j*(%3.3f)',real(Z3L8_50),imag(Z3L8_50))

% Verwende equ 2.3
% Quelle fuer equ: http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
r_ZL8_50=(ZL8_50-1)/(ZL8_50+1); % Reflexionsfaktor 
r_Z3L8_50=(Z3L8_50-1)/(Z3L8_50+1); % Reflexionsfaktor 

% Ermittle Z' ( l=lambda/8 )
reZL8=real(r_ZL8_50);
imZL8=imag(r_ZL8_50);
plot(reZL8,imZL8,'m*'); hold on
text('Interpreter','latex','String','$$Z(l=\lambda/8)$$',...
	'Position',[(1-1/2)*reZL8 (1-1/5)*imZL8],...
	'FontSize',12,'color','m'); % ZL8
% Ermittle Z' ( l=3*lambda/8 )
reZ3L8=real(r_Z3L8_50);
imZ3L8=imag(r_Z3L8_50);
plot(reZ3L8,imZ3L8,'m*'); hold on
text('Interpreter','latex','String','$$Z(l=3\lambda/8)$$',...
	'Position',[(1-1/5)*reZ3L8 (1-1/5)*imZ3L8],...
	'FontSize',12,'color','m'); % Z3L8

% Aus der Punktenkoordinaten R_L, Z' ( l=lambda/8 ), Z' ( l=3*lambda/8 )
% ermittle [centre radius] f?r ein Kreis, der alle diese Punkte umschliesst
pnt1=[-absRL_50 0];
pnt2=[reZL8 imZL8];
pnt3=[reZ3L8 imZ3L8];
[centre radius]=GHF_calcCircle3Pnts(pnt1, pnt2, pnt3);
xC=centre(1);
yC=centre(2);
GHF_SmChCirArc(xC,yC,radius,1e-2,2*pi,'m','-',2);
