clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 3, Aufgabe 2

% AUFGABENSTELLUNG:
% Der Verbrauchswiederstand R1=20 Ohm soll gemaess der Schaltung an die Quelle mit R2=50 Ohm angepasst werden.
% Ermitteln Sie die kapazitiven Leitwerte wC1 und wC2.
% GEGEBEN:
R1_gegeben=20; % Ohm
R2_gegeben=50; % Ohm
ZL=50; % Ohm % lambda/4-Leitungswiderstand
% EINFACHE UMFORMUNG:
% Normierung auf (willkuerlich) 50 Ohm Widerstandsform
R1=R1_gegeben/ZL; % Ohm % R1=0.4*ZL; normiert
R2=R2_gegeben/ZL; % Ohm %R2=ZL im Smithdiagramm % normiert
% GESUCHT:
% Kapazitive Leitwerte wC1 und wC2

% Smithdiagramm in der Widerstandsform
GHF_SmithChart(1,0); hold on
r_R1=(R1-1)/(R1+1); % Reflexionsfaktor 

% Zeichne das Reflexionsfaktor auf dem Smithdiagramm bei [r_R1,0]
plot(r_R1,0,'r*'); hold on
% Eine Textmarke 'R_1' mithilfe des Latex-Editors auf dem Smithdiagramm
text('Interpreter','latex','String','$$R_1$$',...
	'Position',[(1-1/20)*r_R1 0 ],...
	'FontSize',12,'color','r'); % R1
% Bestimme Mittelpunkte x, y fuer den m-Kreis
Radius_r_R1=(1-r_R1)/2;
xC_r_R1=r_R1+Radius_r_R1;
yC_r_R1=0;
% Zeichne ein halben m-Kreises im Strichpunkt, rot
GHF_SmChCirArc(xC_r_R1,yC_r_R1,Radius_r_R1,0,pi,'r','--',2);

% Zeichne R_2 (blau)
plot(0,0,'b*'); hold on
text('Interpreter','latex','String','$$R_2$$',...
	'Position',[0 0 ],...
	'FontSize',12,'color','b'); % R2
Radius_r_R2=1/2;
xC_r_R2=-1/2;
yC_r_R2=0;
% Zeichne ein voller m-Kreises im Strichpunkt (blau)
GHF_SmChCirArc(xC_r_R2,yC_r_R2,Radius_r_R2,1e-2,2*pi,'b','--',2);

% Bestimme Schnittpunkte (hier: nur zwei) der Kreise fuer R_2 und R_1
[x1_r_Zs,y2_r_Zs]=circcirc(-1/2,0,1/2,r_R1+Radius_r_R1,0,Radius_r_R1); % circcirc(x1,y1,r1,x2,y2,r2)
% Bestimme den Punkt Zs % Beschraenkung auf das 2. Quadrant im Smithdiagramm
if (x1_r_Zs(1)<0 && y2_r_Zs(1)>0) % im 2. Quadrant
	r_Zs=x1_r_Zs(1)+j*y2_r_Zs(1);
elseif (x1_r_Zs(2)<0 && y2_r_Zs(2)>0) % im 2. Quadrant
	r_Zs=x1_r_Zs(2)+j*y2_r_Zs(2);
else
	sprintf('Es gibt keine Schnittpunkte im Intervall (pi/2;pi) in der Drehung auf dem m-Kreis fuer den Punkt Zs.')
	r_Zs=nan+j*nan;
end
angleCenterSmithChart_r_Zs=atan2(imag(r_Zs),real(r_Zs)); % Bestimme den Winkel auf r_Zs von (0;0) im Smithdiagramm
angleCenterR1_r_Zs=atan2(imag(r_Zs),real(r_Zs)-xC_r_R1); % Bestimme den Winkel auf r_Zs von (xC_r_R1;0) im Smithdiagramm
GHF_SmChCirArc(xC_r_R1,yC_r_R1,Radius_r_R1,angleCenterR1_r_Zs,pi,'r','-',2); % L_S auf dem m-Kreis (rote Linie)
angleCenterR2_r_Zs=atan2(imag(r_Zs),real(r_Zs)-xC_r_R2); % Bestimme den Winkel auf r_Zs von (xC_r_R2;0) im Smithdiagramm
GHF_SmChCirArc(xC_r_R2,yC_r_R2,Radius_r_R2,0,angleCenterR2_r_Zs,'b','-',2); % C_2 auf dem m-Kreis in (blaue Linie)

% Testmarken auf dem Smithdiagramm
text('Interpreter','latex','String','$$GZ_L=1$$',...
	'Position',[(1+1/2)*(real(r_Zs)) (1+1/5)*imag(-r_Zs) ],...
	'FontSize',12,'color','b'); % GZL=1
text('Interpreter','latex','String','$$L_S$$',...
	'Position',[(1-1/10)*r_R1 (1+1/10)*imag(r_Zs)/2 ],...
	'FontSize',12,'color','r'); % LS
text('Interpreter','latex','String','$$C_2$$',...
	'Position',[0 (1+1/10)*imag(r_Zs)/2 ],...
	'FontSize',12,'color','b'); % C2

% Zeichne r_Zs (magneta)
plot(real(r_Zs),imag(r_Zs),'m*'); hold on
text('Interpreter','latex','String','$$Z_S$$',...
	'Position',[(1-1/10)*real(r_Zs) (1+1/20)*imag(r_Zs) ],...
	'FontSize',12,'color','m'); % ZS
% Quelle fuer equ: http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
Radius_r_Zs=1/((-2*imag(-r_Zs))/((1+real(-r_Zs))^2+imag(-r_Zs)^2)); % equ 3.17 & 3.5
% Bestimme Mittelpunkte x, y fuer den m-Kreis
xC_r_Zs=1;
yC_r_Zs=Radius_r_Zs;
angleCenter_r_Zs=atan2(imag(r_Zs)-yC_r_Zs,real(r_Zs)-xC_r_Zs);
% Auftragen eines vollen m-Kreises im Strichpunkt (magneta)
GHF_SmChCirArc(xC_r_Zs,yC_r_Zs,Radius_r_Zs,0,angleCenter_r_Zs,'m','--',2);
% Auftragen von Strahlen von r_Zs bis r_Ys (magneta)
plot([-real(r_Zs) real(r_Zs)],[-imag(r_Zs) imag(r_Zs)],'m-','LineWidth',2);
% Auftragen von r_Ys (magneta)
plot(-real(r_Zs),-imag(r_Zs),'m*'); hold on
text('Interpreter','latex','String','$$Y_S$$',...
	'Position',[(1+1/10)*(-real(r_Zs)) (1+1/10)*(-imag(r_Zs)) ],...
	'FontSize',12,'color','m'); % YS
Radius_r_Ys=1/((-2*imag(r_Zs))/((1+real(r_Zs))^2+imag(r_Zs)^2)); % equ 3.17 & 3.5
% Bestimme Mittelpunkte x, y fuer den m-Kreis
xC_r_Ys=1;
yC_r_Ys=Radius_r_Ys;
angleCenter_r_Ys=atan2(imag(-r_Zs)-yC_r_Ys,real(-r_Zs)-xC_r_Ys);
% Zeichne ein m-Kreis im Strichpunkt (magneta)
GHF_SmChCirArc(xC_r_Ys,yC_r_Ys,Radius_r_Ys,angleCenter_r_Ys,2*pi,'m','--',2);

% Schnittpunkt Z_S
ZScross=(1+(real(r_Zs)+j*imag(r_Zs)))/(1-(real(r_Zs)+j*imag(r_Zs))); % equ 2.4
% Quelle fuer equ: http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
% Serienaschaltung einer Spule LS (R-Kreis)
wLs=imag(ZScross)*ZL;
% Parallelschaltung der Kapazitaet C2 (G-Kreis)
wC1=wLs/(ZL^2)*1e3;
sprintf('wC1=%3.4fmS',wC1)

YScross=1/ZScross;
% Parallelleitwert wC2:
wC2=-(imag(YScross)/ZL)*1e3;
sprintf('wC2=%3.4fmS',wC2)
