clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 3, Aufgabe 3

% AUFGABENSTELLUNG:
% Gegeben sei eine Schaltung auf dem Aufgabenblatt.
% Fuer welche Leitwerte Y, dargestellt in einem Smith-Diagramm (Leitwertform), laesst sich die Transformationsschaltung 
% so einstellen, dass in der (z=0)-Ebene Anpassung herrscht?
% Bezeichnenn Sie den Bereich
% Waehlen Sie den Bezugswiederstand des Diargamma selbst
% Beschreiben Sie kurz den Loesungsweg.
% GEGEBEN:
% l2=0.1*lambda;
drehWinkelR2R3=-4*pi/10*180/pi; % Grad 
% Weiter rechne mit dem Betrag
relDrehWinkelR2R3=abs(drehWinkelR2R3);
ZL_100=100; % Ohm % Bezugswiderstand

GHF_SmithChart(0,1); hold on % Smithdiagramm in der Leitwertform
% Transformationsrichtung: Y unbekannt -> Beginn mit ZL_50 und anpassen mit Y*
ZL_50=50; % Ohm
% Unterteilung in mehrere Schnittebenen r1, r2, r3, r4: r4 -> Y4=!=Y*
% Einzeichnen von Y1*ZL_100
Y1_gegeben=1/ZL_50;
Y1=Y1_gegeben*ZL_100; % normiert
% Quelle fuer equ: http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
r_Y1=(1-Y1)/(1+Y1); % equ 3.1 % Reflexionsfaktor fuer Admittanz

% Fuer Anpassung: Y=Y4*
% Parallelschaltung einer Reaktanzleitung (ZL_50=50), Kurzschluss am Ende; L=0 ... lambda/2
% d.h. alle Blindleitwerrte von -Infinity bis +Infinity werden erreicht.
% -> in S.D. Kreis G*ZL=2 -> r2 siehe S.D.
Radius_re_r_Y1=1/(1+((1-real(r_Y1)^2-imag(r_Y1)^2)/((1+real(r_Y1))^2+imag(r_Y1)^2))); % equ 3.4 & 3.12 mit 1/(1+g)
xC_re_r_Y1=Radius_re_r_Y1-1;
yC_re_r_Y1=1e-3; % hat sign(yC_re_r_Y1)=1, merke: sign(0)=0
absCenterR1=sqrt(xC_re_r_Y1^2+yC_re_r_Y1^2);

% Leitungstransformation L2=lambda/10, ZL_100=100 Ohm
% -> m-Kreis um phi=-(4*pi/lambda)*L2=/=-72? drehen -> r3 siehe S.D.
% Berechne mit dem Betrag von phi (=abs(drehWinkelR2R3)) und beachte 
% das Vorzeichen mittels relevanten sign(xC_re_r_Y1) & sign(yC_re_r_Y1)
xC_re_r_Y1_dreh=sign(xC_re_r_Y1)*absCenterR1*cos(relDrehWinkelR2R3*pi/180);
yC_re_r_Y1_dreh=sign(yC_re_r_Y1)*absCenterR1*sin(relDrehWinkelR2R3*pi/180);

% Parallelschaltung eines Kondensators (veraenderl.) ausgehend von der Kreispunkten des r3-Kreises auf 
% G=const.-Kreisen im Uhrzeigersinn bis zum Kurzschlusspunkt. Das bezeichnete Gebiet r4 zeigt den erreichbaren 
% Bereich des Reflexionsfaktors r4 bzw. der Admittanz Y4.
absCenterCirclesR2R3=sqrt((xC_re_r_Y1-xC_re_r_Y1_dreh)^2+(yC_re_r_Y1-yC_re_r_Y1_dreh)^2);
absR2R3=absCenterCirclesR2R3-2*Radius_re_r_Y1; % Abstand zw. der Kreisen f?r r2 & r3
winkelCenterR2centerR3=180-2*relDrehWinkelR2R3; % Gleichschenkliges Dreieck
r_randR3zu_xC_r4klein=xC_re_r_Y1+sin(pi/180*winkelCenterR2centerR3)*(Radius_re_r_Y1+absR2R3);
r_randR3zu_yC_r4klein=yC_re_r_Y1+cos(pi/180*winkelCenterR2centerR3)*(Radius_re_r_Y1+absR2R3);
r_randR3=r_randR3zu_xC_r4klein+j*r_randR3zu_yC_r4klein;

% Berechne Koordinaten fuer das Kreis von r2 bis r3 nah zum r1-Punkt 
Radius_re_r_randR3=1/(1+((1-real(r_randR3)^2-imag(r_randR3)^2)/((1+real(r_randR3))^2+imag(r_randR3)^2))); % equ 3.4 & 3.12 mit 1/(1+g)
xC_re_r_randR3=Radius_re_r_randR3-1;
yC_re_r_randR3=0;
angleCenter_r_randR3vonR2=atan2(imag(r_randR3)-yC_re_r_randR3,real(r_randR3)-xC_re_r_randR3);
% Zeichne ein m-Kreis von r2 bis r3 nah zum r1-Punkt (rote und magneta Linie)
GHF_SmChCirArc(xC_re_r_randR3,-yC_re_r_randR3,Radius_re_r_randR3,-angleCenter_r_randR3vonR2,0,'r','-',2);
GHF_SmChCirArc(xC_re_r_randR3,-yC_re_r_randR3,Radius_re_r_randR3,0,pi,'m','-',2);

if (xC_re_r_Y1<0 && yC_re_r_Y1>0) % im 2. Quadrant
    angleCenter_1Kreis_r3=(180-relDrehWinkelR2R3)*pi/180;
elseif (xC_re_r_Y1<0 && yC_re_r_Y1<0) % im 3. Quadrant
    angleCenter_1Kreis_r3=(180+relDrehWinkelR2R3)*pi/180;
elseif (xC_re_r_Y1>0 && yC_re_r_Y1<0) % im 4. Quadrant
    angleCenter_1Kreis_r3=(360-relDrehWinkelR2R3)*pi/180;
elseif (xC_re_r_Y1<0 && yC_re_r_Y1<0) % im 1. Quadrant
    angleCenter_1Kreis_r3=(relDrehWinkelR2R3)*pi/180;
end
% Zeichne ein m-Kreis von r2 bis r3 am Rand des Smithdiagramms (rote und magneta Linie)
GHF_SmChCirArc(0,0,1,-angleCenter_1Kreis_r3,0,'r','-',2);
GHF_SmChCirArc(0,0,1,0,pi,'m','-',2);

angleCenter_r_randR3beiR2=pi+angleCenter_r_randR3vonR2;
GHF_SmChCirArc(xC_re_r_Y1_dreh,-yC_re_r_Y1_dreh,Radius_re_r_Y1,angleCenter_1Kreis_r3,angleCenter_r_randR3beiR2,'r','-',2);

% Zeichne zwei Geraden vom Rand des m-Kreises von r2 bis r3 nah zum r1-Punktam zum Rand des Smithdiagramms
plot([(xC_re_r_randR3+Radius_re_r_randR3) 1],[1e-2 1e-2],'m-','LineWidth',2);
plot([(xC_re_r_randR3+Radius_re_r_randR3) 1],[-1e-2 -1e-2],'r-','LineWidth',2);
text('Interpreter','latex','String','$$Y$$',...
	'Position',[(1-1/10)*(xC_re_r_randR3+Radius_re_r_randR3) 0.1],...
	'FontSize',12,'color','m'); % bei r4klein

