clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 3, Aufgabe 4

% AUFGABENSTELLUNG:
% Die Impendanz Z soll mithilfe einer lambda/4-Leitung und eines Serienkondensators an 50 Ohm angepasst werden.
% Der Wellenwiderstand der lambda/4-Leitung darf aus konstrukieven Gr?nden nur zwischen 20 Ohm und 80 Ohm betragen:
% Schraffieren Sie in einem auf 50 Ohm normierten Smith-Diagramm den Bereich der Impendanzen Z, der an 50 Ohm angepasst werden kann.
% GEGEBEN:
ZL1_gegeben=50; % Ohm
Zref=50; % Ohm 
ZL2_c=20; % Ohm % Fall a) auf dem Loesungsblatt
ZL2_d=80; % Ohm % Fall b) auf dem Loesungsblatt
% GESUCHT:
% Drehung auf m-Kreis

% Teilaufgabe b)
Z2u=1/ZL1_gegeben*ZL2_c; % Fall a) auf dem Loesungsblatt
Z2o=1/ZL1_gegeben*ZL2_d; % Fall b) auf dem Loesungsblatt
ZL1=ZL1_gegeben/Zref;
Z2u=Z2u*ZL2_c/Zref;
sprintf('Z2u=%3.3f*50 Ohm',Z2u)
Z2o=Z2o*ZL2_d/Zref;
sprintf('Z2o=%3.3f*50 Ohm',Z2o)

GHF_SmithChart(1,0); hold on % Smithdiagramm in der Widerstandsform

% Zeichne ein m-Kreis fuer Z2u (magneta Linie)
r_Z2u=(Z2u-1)/(Z2u+1); % Reflexionsfaktor
Theta_r_Z2u=atan2(imag(r_Z2u),real(r_Z2u));
Radius_r_Z2u=(1-r_Z2u)/2;
xC_r_Z2u=r_Z2u+Radius_r_Z2u;
yC_r_Z2u=0;
GHF_SmChCirArc(xC_r_Z2u,yC_r_Z2u,Radius_r_Z2u,0,Theta_r_Z2u,'m','-',2);

% Zeichne ein m-Kreis fuer Z2o (magneta Linie)
r_Z2o=(Z2o-1)/(Z2o+1); % Reflexionsfaktor
Theta_r_Z2o=atan2(imag(r_Z2o),real(r_Z2o));
Radius_r_Z2o=(1-r_Z2o)/2;
xC_r_Z2o=r_Z2o+Radius_r_Z2o;
yC_r_Z2o=0;
GHF_SmChCirArc(xC_r_Z2o,yC_r_Z2o,Radius_r_Z2o,Theta_r_Z2o,pi,'m','-',2);

% Hilfsobjekte
Z2u=-sqrt(real(r_Z2u)^2+imag(r_Z2u)^2); % =abs(r_Z2u)
plot(Z2u,0,'m*'); hold on
text('Interpreter','latex','String','$$Z_{2u}$$',...
	'Position',[(1-1/10)*Z2u -0.05],...
	'FontSize',12,'color','m'); % Z2u

Z2o=sqrt(real(r_Z2o)^2+imag(r_Z2o)^2);
plot(Z2o,0,'m*'); hold on
text('Interpreter','latex','String','$$Z_{2o}$$',...
	'Position',[(1-1/10)*Z2o -0.05],...
	'FontSize',12,'color','m'); %Z2o

text('Interpreter','latex','String','$$Z_{L1}$$',...
	'Position',[-0.05 -0.05],...
	'FontSize',12,'color','m'); % ZL1
text('Interpreter','latex','String','$$Z$$',...
	'Position',[0 (1-1/10)*Z2o],...
	'FontSize',12,'color','m'); % Z
plot([Z2u Z2o],[0 0],'m-','LineWidth',2);
