clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 4, Aufgabe 2

% AUFGABENSTELLUNG:
% Die Spannungaverteilung einer 240 Ohm - Doppelleitung wird abgetastet. 
f=300*1e6; % Hz % nach der freien Wahl
c_vac=3*1e8;
lambda=c_vac/f; % m
beta=2*pi/lambda;
% GEGEBEN:
ZL=240; % Ohm
% Geben Sie den Reflexionsfaktor r am Leitungsende z=0 nach Betrag und Phase an.
% GESUCHT: r

% Frei gewaehlte Parameter:
a0=1;
b0=1;
zDLvon=0;
zDLstep=0.01;
zDLbis=1.5;
zDL=zDLvon:zDLstep:zDLbis; % zDL ist z durch lambda
%{ % Test
phi=0; % r=1 % Leerlauf
U=sqrt(ZL)*(a0*exp(i*(beta*zDL+phi))+b0*exp(-i*(beta*zDL+phi)));
I=1/sqrt(ZL)*(a0*exp(i*(beta*zDL+phi))-b0*exp(-i*(beta*zDL+phi)));
%}

% Leitungsgleichungen fuer stehende Wellen fuer den unbekannten Anschluss
a0UnbekAn=0.22; % freie Wahl des Koeffizienten fuer einen unbekannten Anschluss
a0=a0UnbekAn;
b0UnbekAn=0.14; % freie Wahl des Koeffizienten fuer einen unbekannten Anschluss
b0=b0UnbekAn;
phiUnbekAn=pi/5; %pi/2; % r=j; % l/lambda=0.125; % Unbekannter Abschluss
phi=phiUnbekAn;
U=sqrt(ZL)*(a0*exp(i*(beta*zDL+phi))+b0*exp(-i*(beta*zDL+phi)));
UabsUnbekAn=abs(U);

% Leitungsgleichungen fuer stehende Wellen fuer den Kurzschluss
a0Kurzschluss=1; % frei, um den unbekannten Anschluss gemaess der Amplitude anzupassen
a0=a0Kurzschluss;
b0Kurzschluss=5; % frei, um den unbekannten Anschluss gemaess der Amplitude anzupassen
b0=b0Kurzschluss;
phi=pi; % r=-1; % l/lambda=0; % Kurzschluss
U=sqrt(ZL)*(a0*exp(i*(beta*zDL+phi))+b0*exp(-i*(beta*zDL+phi)));
UabsKurzschluss=abs(U);

% Zeichne stehende Wellen
[AX,H1,H2]=plotyy(zDL,UabsKurzschluss, zDL,UabsUnbekAn,'plot'); % links & rechts
xlabel('z/\lambda')
title('Spannungsverlauf auf der Messleitung')
set(H1,'LineStyle','--','LineWidth',2) % links
set(H2,'LineStyle','-','LineWidth',2) % rechts
set(get(AX(1),'Ylabel'),'String','Kurzschluss, |U(z)|') % links
set(get(AX(2),'Ylabel'),'String','Unbekannter Abschluss, |U(z)|')

% in der folgenden Schleife wird nach zDLminUnbekAn & zDLkurzschluss gesucht
zDLunbekAn=0;
UminAbsUnbekAn=sqrt(ZL); % freie Wahl des Initialisierungswertes
for zDL=zDLvon:zDLstep:zDLbis
	phi=phiUnbekAn; % unbekannter Anschluss
	a0=a0UnbekAn;
	b0=b0UnbekAn;
	U=sqrt(ZL)*(a0*exp(i*(beta*zDL+phi))+b0*exp(-i*(beta*zDL+phi)));
	if zDL<1
		if abs(U)<UminAbsUnbekAn
			UminAbsUnbekAn=abs(U);
			zDLminUnbekAn=zDL;
		end
    end
	phi=pi; % Kurzschluss
	a0=a0Kurzschluss;
	b0=b0Kurzschluss;
	U=sqrt(ZL)*(a0*exp(i*(beta*zDL+phi))+b0*exp(-i*(beta*zDL+phi)));
	if ((abs(U)<1e-2) && (zDL>zDLminUnbekAn && zDL<2*zDLminUnbekAn))
		hold on
		plot([zDL zDL],[0 1.5*sqrt(ZL)*a0],'color','k','LineWidth',2) % Hilfsvertikale: WKP
		hold on
		zDLkurzschluss=zDL;
	end
end
hold on
plot([zDLminUnbekAn zDLminUnbekAn],[0 sqrt(ZL)*a0],'color','k','LineWidth',2) % Hilfsvertikale: fuer z0, davon bis auf WKP
hold on
% Textmarken
text(zDLminUnbekAn,UminAbsUnbekAn,'\leftarrow','color','black',...
     'HorizontalAlignment','left','FontSize',13)
text(zDLminUnbekAn,(1+1/10)*UminAbsUnbekAn,'z_0','color','black',...
     'HorizontalAlignment','left','FontSize',13)
text(zDLkurzschluss,UminAbsUnbekAn,'\rightarrow','color','black',...
     'HorizontalAlignment','right','FontSize',13)
text(zDLkurzschluss,sqrt(ZL)*a0,'\leftarrow WKP','color','black',...
     'HorizontalAlignment','left','FontSize',13)
z0=abs(zDLkurzschluss-zDLminUnbekAn); % eine zeichnerische L?sung

% WKP oder Wiederkehrpunkt
delta=2*beta*z0-pi;
m=min(UabsUnbekAn)/max(UabsUnbekAn);
rAbs=(1-m)/(1+m);
r=rAbs*exp(i*delta);
sprintf('Rechnerische Loesung fuer den komplexen Reflexionsfaktors r = %3.4f * exp(j*(%3.2f?)) ',abs(r),180/pi*angle(r))


