clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 5, Aufgabe 1

% AUFGABENSTELLUNG:
% Gegeben ist ein Mikrowellenverst?rker in Streifenleitunstechnik.
% Alle Streifenleitungen besitzen einen Wellenwiderstand von 50 Ohm.
% GEGEBEN:
Z_gegeben=50; % Ohm
% Bei der Betriebsfrequenz sind gegeben:
% Die bezogenen Leitungslaengen:
L0DL=0.1; % l0DL ist l0/lambda
L1DL=0.354;
L2DL=0.011;
L3DL=0.079;
L4DL=0.1;
L5DL=0.092;
L6DL=0.121;
L7DL=0.131;
% Die Streuparameter des Transistors (Bezugsebene jeweils direkt am Transistorgehaeuse):
S11=0.865*exp(142*j*pi/180); % pi/180 dient zur Umrechnung in den Bogenmassskala
S12=0.047*exp(-12*j*pi/180);
S21=1.092*exp(-1*j*pi/180);
S22=0.465*exp(-175*j*pi/180);
% Die Schaltung ist am Eingang und am Ausgang:
% eigenreflexionsfrei bezogen auf 50 Ohm,
% mit 50 Ohm abgeschlossen.
ZL=50; % Ohm
Z=Z_gegeben/ZL; % normiert
% Bestimmen Sie den Reflexionsfaktor rq.
% GESUCHT: rq = r_rq = (rqStern)*

GHF_SmithChart(0,1); hold on % Smithdiagramm in der Leitwertform
r_Z=(Z-1)/(Z+1); % Reflexionsfaktor, Z ist normiert % bei ZL=50 ist r_Z=0

% Zeichne r_a
plot(real(r_Z),imag(r_Z),'m*'); hold on
text('Interpreter','latex','String','$$r_a$$',...
	'Position',[0.02 0.02],...
	'FontSize',12,'color','m'); % r_a

% Berechne YBmalZL
% Parallelschaltung zweier leerlaufende Leitungen der Laenge L5DL
BL5malZL=tan((2*pi)*L5DL); % GHF_Skript, S.104, Formel (5.65)
YBmalZL=1/Z+j*2*BL5malZL; % Y_b
sprintf('YBmalZL = %3.4f + j*(%3.4f) ',real(YBmalZL),imag(YBmalZL))

% Zeichne r_b
r_YBmalZL=(1-YBmalZL)/(1+YBmalZL); % Reflexionsfaktor fuer Admittanz
plot(real(r_YBmalZL),imag(r_YBmalZL),'m*'); hold on
text('Interpreter','latex','String','$$r_b$$',...
	'Position',[(1+1/20)*real(r_YBmalZL) (1+1/20)*imag(r_YBmalZL)],...
	'FontSize',12,'color','m'); % rb

% Zeichne l_5
Radius_L5=1/2;
xC_L5=-1/2;
yC_L5=0;
angleCenter_L5=atan2(imag(r_YBmalZL),real(r_YBmalZL)-xC_L5);
GHF_SmChCirArc(xC_L5,yC_L5,Radius_L5,angleCenter_L5,0,'r','-',2);
[numlDL_YBmalZL numTheta_YBmalZL]=GHF_SmChRay([real(r_YBmalZL) imag(r_YBmalZL)],'r');
% Kettenleitung L1=0.354*lambda (m-Kreis)
% Skala: 1/lambda=lDL_YCmalZL
lDL_YCmalZL=L1DL-(0.5-numlDL_YBmalZL);
Theta_YCmalZL=(1-4*lDL_YCmalZL)*pi;
radius_r_YBmalZL=sqrt(real(r_YBmalZL)^2+imag(r_YBmalZL)^2); % nutze aus: radius_r_YCmalZL=radius_r_YBmalZL

% Berechne YCmalZL
re_r_YCmalZL=radius_r_YBmalZL*cos(Theta_YCmalZL);
im_r_YCmalZL=radius_r_YBmalZL*sin(Theta_YCmalZL);
r_YCmalZL=re_r_YCmalZL+j*im_r_YCmalZL;
YCmalZL=(1-r_YCmalZL)/(1+r_YCmalZL); % GHF_Skript, Seite 84, F.(5.35)
sprintf('YCmalZL = %3.4f + j*(%3.4f) ',real(YCmalZL),imag(YCmalZL))

% Zeichne l_1
[numlDL_YCmalZL numTheta_YCmalZL]=GHF_SmChRay([re_r_YCmalZL im_r_YCmalZL],'m');
GHF_SmChCirArc(0,0,radius_r_YBmalZL,numTheta_YCmalZL*pi/180,numTheta_YBmalZL*pi/180); % L1-Kreis

% Berechne YDmalZL
% Parallelschaltung zweier Leitungen mit L7=0.131*lambda
BL7malZL=tan(L7DL*(2*pi)); % GHF_Skript, S.104, F.(5.65)
YDmalZL=YCmalZL+j*2*BL7malZL; % Admittanz
sprintf('YDmalZL = %3.4f + j*(%3.4f) ',real(YDmalZL),imag(YDmalZL))

% Zeichne l_7
% Quelle fuer equ: http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
r_YDmalZL=(1-YDmalZL)/(1+YDmalZL); % equ 3.1 % Reflexionsfaktor f?r Admittanz
Radius_re_r_YDmalZL=1/(1+((1-real(r_YDmalZL)^2-imag(r_YDmalZL)^2)/((1+real(r_YDmalZL))^2+imag(r_YDmalZL)^2))); % equ 3.12 & 3.4
xC_r_YDmalZL=Radius_re_r_YDmalZL-1;
yC_r_YDmalZL=0;
angleCenterYDmalZL_r_YDmalZL=atan2(imag(r_YCmalZL),real(r_YCmalZL)-xC_r_YDmalZL);
angleCenterTheta_YCmalZL=atan2(imag(r_YDmalZL),real(r_YDmalZL)-xC_r_YDmalZL);
GHF_SmChCirArc(xC_r_YDmalZL,yC_r_YDmalZL,Radius_re_r_YDmalZL,angleCenterTheta_YCmalZL,angleCenterYDmalZL_r_YDmalZL,'b','-',2); % L7-Kreis

% Zeichne r_d
[numlDL_YDmalZL numTheta_YDmalZL]=GHF_SmChRay([real(r_YDmalZL) imag(r_YDmalZL)],'b');
text('Interpreter','latex','String','$$r_d$$',...
	'Position',[(1+1/20)*real(r_YDmalZL) (1+1/20)*imag(r_YDmalZL)],...
	'FontSize',12,'color','m'); % r_d

% Zeichne r_Q
numlDL_rq=numlDL_YDmalZL+L2DL;
Theta_rq=(1-4*numlDL_rq)*pi;
radius_r_rq=sqrt(real(r_YDmalZL)^2+imag(r_YDmalZL)^2); % radius_r_rq = r_YDmalZL
re_r_rq=radius_r_rq*cos(Theta_rq);
im_r_rq=radius_r_rq*sin(Theta_rq);
r_rq=re_r_rq+j*im_r_rq; % Reflexionsfaktor
text('Interpreter','latex','String','$$r_Q$$',...
	'Position',[(1+1/20)*re_r_rq (1+1/20)*im_r_rq],...
	'FontSize',12,'color','m'); % rq % Reflexionsfaktor
% Zeichne r_q
[numlDL_r_rq numTheta_r_rq]=GHF_SmChRay([re_r_rq im_r_rq],'m');
GHF_SmChCirArc(0,0,radius_r_rq,numTheta_r_rq*pi/180,numTheta_YDmalZL*pi/180);

% Berechne rq & rq*
sprintf('rq = %3.4f * exp(j*(%3.4f?)) ',abs(r_rq),numTheta_r_rq)
rqStern=conj(r_rq);
sprintf('rq* = %3.4f * exp(j*(%3.4f?)) ',abs(rqStern),180/pi*atan2(imag(rqStern),real(rqStern)))
