clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 5, Aufgabe 1

% AUFGABENSTELLUNG:
% Gegeben ist ein Mikrowellenverst?rker in Streifenleitunstechnik.
% Alle Streifenleitungen besitzen einen Wellenwiderstand von 50 Ohm.
% GEGEBEN:
Z_gegeben=50; % Ohm
% Bei der Betriebsfrequenz sind gegeben:
% Die bezogenen Leitungsl?ngen:
L0DL=0.1; % l0DL ist l0/lambda
L1DL=0.354;
L2DL=0.011;
L3DL=0.079;
L4DL=0.1;
L5DL=0.092;
L6DL=0.121;
L7DL=0.131;
% Die Streuparameter des Transistors (Bezugsebene jeweils direkt am Transistorgeh?use):
S11=0.865*exp(142*j*pi/180); % pi/180 dient zur Umrechnung in den Bogenma?skala
S12=0.047*exp(-12*j*pi/180);
S21=1.092*exp(-1*j*pi/180);
S22=0.465*exp(-175*j*pi/180);
% Die Schaltung ist am Eingang uns am Ausgang:
% eigenreflexionsfrei bezogen auf 50 Ohm,
% mit 50 Ohm abgeschlo?en.
ZL=50; % Ohm
Z=Z_gegeben/ZL; % normiert
% Warum ist rq = r_rq =/= (S11)* ?
% GESUCHT: r1 = (rqStern)*

GHF_SmithChart(0,1); hold on % Smithdiagramm in der Leitwertform
% Aus der Teilaufgabe a) werden die ausgerechnete Werte uebernommen:
% Parallelschaltung zweier leerlaufendere Leitungen der Laenge l5DL

% Berechne YBmalZL
BL5malZL=tan(L5DL*(2*pi)); % GHF_Skript, S.104, Formel (5.65)
YBmalZL=1/Z+j*2*BL5malZL; % Y_b
%sprintf('YBmalZL = %3.4f + j*(%3.4f) ',real(YBmalZL),imag(YBmalZL))
r_YBmalZL=exp(j*pi)*(YBmalZL-1)/(YBmalZL+1); % Reflexionsfaktor

% Berechne YCmalZL
Radius_L5=1/2;
xC_L5=-1/2;
yC_L5=0;
angleCenter_L5=atan2(imag(r_YBmalZL),real(r_YBmalZL)-xC_L5);
[numlDL_YBmalZL numTheta_YBmalZL]=GHF_SmChRay([real(r_YBmalZL) imag(r_YBmalZL)],'r');
GHF_plotUndo(8); % behalte den Wert numlDL_YBmalZL und loesche das Uebrige in der Zeichnung GHF_SmChRay
% Kettenleitung L1=0.354*lambda (m-Kreis)
% Skala: 1/lambda=lDL_YCmalZL
lDL_YCmalZL=L1DL-(0.5-numlDL_YBmalZL); % lDL ist l/lambda
Theta_YCmalZL=(1-4*lDL_YCmalZL)*pi;
radius_r_YBmalZL=sqrt(real(r_YBmalZL)^2+imag(r_YBmalZL)^2); % nutze aus, dass radius_r_YCmalZL=radius_r_YBmalZL
re_r_YCmalZL=radius_r_YBmalZL*cos(Theta_YCmalZL);
im_r_YCmalZL=radius_r_YBmalZL*sin(Theta_YCmalZL);
r_YCmalZL=re_r_YCmalZL+j*im_r_YCmalZL;
YCmalZL=(1-r_YCmalZL)/(1+r_YCmalZL); % GHF_Skript, Seite 84, F.(5.35)
%sprintf('YCmalZL = %3.4f + j*(%3.4f) ',real(YCmalZL),imag(YCmalZL))

% Berechne YDmalZL
[numlDL_YCmalZL numTheta_YCmalZL]=GHF_SmChRay([re_r_YCmalZL im_r_YCmalZL],'m');
GHF_plotUndo(8); % behalte den Wert numTheta_YCmalZL und loesche das Uebrige in der Zeichnung GHF_SmChRay
% Parallelschaltung zweier Leitungen mit L7=0.131*lambda
BL7malZL=tan(L7DL*(2*pi)); % GHF_Skript, S.104, F.(5.65)
YDmalZL=YCmalZL+j*2*BL7malZL; % aus dem Smithdiagramm abzulesen
%sprintf('YDmalZL = %3.4f + j*(%3.4f) ',real(YDmalZL),imag(YDmalZL))

% Quelle fuer equ: http://www.maxic.com/appnotes.cfm/appnote_number/742/
r_YDmalZL=(1-YDmalZL)/(1+YDmalZL); % equ 3.1 % Reflexionsfaktor fuer Admittance
Radius_re_r_YDmalZL=1/(1+((1-real(r_YDmalZL)^2-imag(r_YDmalZL)^2)/((1+real(r_YDmalZL))^2+imag(r_YDmalZL)^2))); % equ 3.12 & 3.4
xC_r_YDmalZL=Radius_re_r_YDmalZL-1;
yC_r_YDmalZL=0;
angleCenterYDmalZL_r_YDmalZL=atan2(imag(r_YCmalZL),real(r_YCmalZL)-xC_r_YDmalZL);
angleCenterTheta_YCmalZL=atan2(imag(r_YDmalZL),real(r_YDmalZL)-xC_r_YDmalZL);

[numlDL_YDmalZL numTheta_YDmalZL]=GHF_SmChRay([real(r_YDmalZL) imag(r_YDmalZL)],'b');
GHF_plotUndo(8); % behalte den Wert numTheta_YDmalZL und loesche das Uebrige in der Zeichnung GHF_SmChRay
numlDL_rq=numlDL_YDmalZL+L2DL;
Theta_rq=(1-4*numlDL_rq)*pi;
radius_r_rq=sqrt(real(r_YDmalZL)^2+imag(r_YDmalZL)^2); % radius_r_rq=r_YDmalZL
% Berechne den Reflexionsfaktor rq
r_rq=radius_r_rq*(cos(Theta_rq)+j*sin(Theta_rq));

% Teilaufgabe b)
r_Z=(Z-1)/(Z+1); % Reflexionsfaktor, Z ist normiert % bei ZL=50 ist r_Z=0
plot(0,0,'m*'); hold on
text('Interpreter','latex','String','$$50 \Omega$$',...
	'Position',[0.02 0.02],...
	'FontSize',12,'color','m'); %50 Ohm

% Berechne Y_L6L3
% Parallelschaltung zweier Leitungen mit L6=0.121*lambda
BL6malZL=tan(L6DL*(2*pi)); % GHF_Skript, S.104, F.(5.65)
Y_L6L3=1/Z+j*2*BL6malZL; % Admittanz
%sprintf('Y_L6L3 = %3.4f + j*(%3.4f) ',real(Y_L6L3),imag(Y_L6L3))

% Zeichne "l_6"
% G*ZL=const-Kreis
% http://www.maxim-ic.com/appnotes.cfm/appnote_number/742/
r_Y_L6L3=(1-Y_L6L3)/(1+Y_L6L3); % equ 3.1 % Reflexionsfaktor fuer Admittanz
Radius_L6=1/2;
xC_L6=-1/2;
yC_L6=0;
angleCenter_L6=atan2(imag(r_Y_L6L3),real(r_Y_L6L3)-xC_L6);
GHF_SmChCirArc(xC_L6,yC_L6,Radius_L6,angleCenter_L6,0,'r','-',2);
[numlDL_r_Y_L6L3 numTheta_r_Y_L6L3]=GHF_SmChRay([real(r_Y_L6L3) imag(r_Y_L6L3)],'r');
% B*ZL=const-Kreis
Radius_im_r_Y_L6L3=1/((-2*imag(r_Y_L6L3))/((1+real(r_Y_L6L3))^2+imag(r_Y_L6L3)^2)); % equ 3.17 & 3.5
xC_im_L6L3=-1;
yC_im_L6L3=-Radius_im_r_Y_L6L3;
angleCenterL6L3_r_Y_L6L3=atan2(imag(r_Y_L6L3)-yC_im_L6L3,real(r_Y_L6L3)-xC_im_L6L3);
GHF_SmChCirArc(xC_im_L6L3,yC_im_L6L3,Radius_im_r_Y_L6L3,pi,angleCenterL6L3_r_Y_L6L3,'b','--',2);

% Warum ist rq =/= (S11)* ?
r2=S22+(S12*S21*r_rq)/(1-S11*r_rq);
r_rL=conj(r2); % gilt fuer optimale Leistungsverstaerkung
[numlDL_r_rL numTheta_r_rL]=GHF_SmChRay([real(r_rL) imag(r_rL)],'m');
% hier bekomme e.Abweichung in der Zeichnung, da S-Parameter des Transistors variieren
% Zeichne r_L
sprintf('rL = %3.4f * exp(j*(%3.4f?)) ',abs(r_rL),numTheta_r_rL)
text('Interpreter','latex','String','r_L',...
	'Position',[(1+1/20)*real(r_rL) (1+1/20)*imag(r_rL)],...
	'FontSize',12,'color','m'); % r_rL
% Zeichne ein m-Kreis (l3 von l6 bis r_L: magneta, Linie; das Uebrige l3: magneta, Strichlinie)
Radius_re_r_rL_Y_L6L3=sqrt(real(r_Y_L6L3)^2+imag(r_Y_L6L3)^2);
xC_r_rL=0;
yC_r_rL=0;
%angleCenterTheta_r_rL=atan2(imag(r_rL),real(r_rL)-xC_r_rL);
GHF_SmChCirArc(xC_r_rL,yC_r_rL,Radius_re_r_rL_Y_L6L3,numTheta_r_rL*pi/180,numTheta_r_Y_L6L3*pi/180,'m','-',2); % rL_L3-Kreis
GHF_SmChCirArc(xC_r_rL,yC_r_rL,Radius_re_r_rL_Y_L6L3,numTheta_r_Y_L6L3*pi/180,numTheta_r_rL*pi/180,'m','--',2); % L3-Kreis

% Vergleich r1 & rq
r1=S11+(S12*S21*r_rL)/(1-S22*r_rL);
sprintf('r1 = %3.4f * exp(j*(%3.4f?)) ',abs(r1),180/pi*atan2(imag(r1),real(r1)))
rqStern=conj(r_rq);
sprintf('rq* = %3.4f * exp(j*(%3.4f?)) ',abs(rqStern),180/pi*atan2(imag(rqStern),real(rqStern)))
