clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 5, Aufgabe 3

% AUFGABENSTELLUNG:
% Gegeben ist ein Zweitor
% GEGEBEN:
Zref_1=25; % Ohm
% Tor 1: hat Bezugswellenwiderstand ZL=50 Ohm
ZL1_gegeben=50; % Ohm
% Tor 2: hat Bezugswellenwiderstand ZL2=50 Ohm
ZL2_gegeben=75; % Ohm
% Welche Kurve durchlaeuft der Streuparameter S11, 
% wenn C von 0 bis Unendlich durchgestimmt wird?
% GESUCHT: S11(C=0...Infty)

% Eingang am Tor 2: Schnittebene a)
YL2_gegeben=1/ZL2_gegeben;
sprintf('YL2=1/%2.0f=(1/%1.0f)*1/%1.0f',1/YL2_gegeben,ZL2_gegeben/Zref_1,Zref_1)

% Ausgang am Tor 1: Schnittebene b)
% Parallel-C
GHF_SmithChart(0,1); hold on % Smithdiagramm in der Leitwertform
YL2=1/(ZL2_gegeben/Zref_1); % normiert
r_YL2=(1-YL2)/(1+YL2); % Reflexionsfaktor fuer Admittanz

% Zeichne den Reflexionsfaktor im G*ZL-Kreis (rot, Strichlinie)
Radius_re_r_YL2=1/(1+((1-real(r_YL2)^2-imag(r_YL2)^2)/((1+real(r_YL2))^2+imag(r_YL2)^2))); % equ 3.12 & 3.4
xC_re_r_YL2=Radius_re_r_YL2-1;
yC_re_r_YL2=0;
% Bewegung auf G*ZL=1/3-Kreis nach unten bis in den Kurzschlusspunkt (C->Infty)
GHF_SmChCirArc(xC_re_r_YL2,yC_re_r_YL2,Radius_re_r_YL2,pi,2*pi,'r','--',2);

% Zeichne Textmarken (rot)
plot(-1,0,'r*'); hold on % C->Infty
punktC0=(Radius_re_r_YL2-1)+Radius_re_r_YL2;
plot(punktC0,0,'r*'); hold on % C=0
text('Interpreter','latex','String','$$C \rightarrow \infty$$',...
	'Position',[(1-1/20)*(-1) -2*0.05],...
	'FontSize',12,'color','r'); % C->Infty
text('Interpreter','latex','String','$$C=0$$',...
	'Position',[(1+1/10)*punktC0 0.05],...
	'FontSize',12,'color','r'); % C=0

% Kettenleitung mit L=lambda/4 -> m-Kresdrehung um -180Grad!
% Eingang am Tor 1: Schnittebene c)
% Zeichne den Reflexionsfaktor (blau, Strichlinie)
xC_re_r_YL2_dreh=-r_YL2+Radius_re_r_YL2;
yC_re_r_YL2_dreh=0;
GHF_SmChCirArc(xC_re_r_YL2_dreh,yC_re_r_YL2_dreh,Radius_re_r_YL2,0,pi,'b','--',2);

% Zeichne Textmarken (blau)
plot(1,0,'b*'); hold on % C->\Infty
punktC0_dreh=-Radius_re_r_YL2+(-r_YL2+Radius_re_r_YL2);
plot(punktC0_dreh,0,'b*'); hold on % C=0
text('Interpreter','latex','String','$$C \rightarrow \infty$$',...
	'Position',[(1-1/3)*(+1) -0.05],...
	'FontSize',12,'color','b'); % C->Infty
text('Interpreter','latex','String','$$C=0$$',...
	'Position',[(1-1/5)*punktC0_dreh 0.05],...
	'FontSize',12,'color','b'); % C=0
