clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 5, Aufgabe 3

% AUFGABENSTELLUNG:
% Gegeben ist ein Zweitor
% GEGEBEN:
Zref_1=25; % Ohm
% Tor 1: hat Bezugswellenwiderstand ZL=50 Ohm
ZL1_gegeben=50; % Ohm
% Tor 2: hat Bezugswellenwiderstand ZL2=50 Ohm
ZL2_gegeben=75; % Ohm
% Welche Kurve durchlaeuft der Streuparameter S11, wenn C von 0 bis Unendlich durchgestimmt wird?
% GESUCHT: S11(C=0...Infty)

% Parallel-C
GHF_SmithChart(0,1); hold on % Smithdiagramm in der Leitwertform
% Jetzt Umnormierung auf 50 Ohm! Da S11 nur fuer Bezugswelllenwiderstand ZL1=50 Ohm definiert ist.
Zref_2=50; % Ohm
Zref_2_durch_Zref_1=Zref_2/Zref_1; % Multiplikationsfaktor -> YL2
sprintf('G=%1.1f/%2.1f=%1.1f/%2.1f',ZL2_gegeben/Zref_1,Zref_1, Zref_2_durch_Zref_1*(ZL2_gegeben/Zref_1), Zref_2_durch_Zref_1*Zref_1)
YL2=1/(Zref_2_durch_Zref_1*(ZL2_gegeben/Zref_1)); % normiert
r_YL2=(1-YL2)/(1+YL2); % Reflexionsfaktor fuer Admittanz

% Halbkreis bleibt Halbkreis. Abbildung der reellen Leitwerte!
% Zeichne den Reflexionsfaktor (blau, Strichlinie)
Radius_re_r_YL2=1/(1+((1-real(r_YL2)^2-imag(r_YL2)^2)/((1+real(r_YL2))^2+imag(r_YL2)^2))); % equ 3.4 & 3.12 <-> 1/(1+g)
xC_re_r_YL2_dreh=-r_YL2+Radius_re_r_YL2;
yC_re_r_YL2_dreh=0;
GHF_SmChCirArc(xC_re_r_YL2_dreh,yC_re_r_YL2_dreh,Radius_re_r_YL2,0,pi,'b','--',2);

% Zeichne Textmarken (blau)
plot(1,0,'b*'); hold on % C->Infty
punktC0_dreh=-Radius_re_r_YL2+(-r_YL2+Radius_re_r_YL2);
plot(punktC0_dreh,0,'b*'); hold on % C=0
text('Interpreter','latex','String','$$C \rightarrow \infty$$',...
	'Position',[(1-1/3)*(+1) -0.05],...
	'FontSize',12,'color','b'); % C->Infty
text('Interpreter','latex','String','$$C=0$$',...
	'Position',[(1-1/5)*punktC0_dreh 0.05],...
	'FontSize',12,'color','b'); % C=0

