clear all
clf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GHF, Uebungsblatt 6, Aufgabe 3

% AUFGABENSTELLUNG:
% Eine Sendeantenne strahlt bei einer Frequenz f=100 MHz
% eine Leistung von 800 W ab. In 100 km Entfernung vom Sender wird 
% eine maximale Feldst?rke von Emax=70 dBmuV gemessen.
% Wie gross ist der Gewinn Gi und die Wirkflaeche Aw dieser Antenne?
% GEGEBEN:
f=1e8; % Hz % Frequenz der Senndeantenne
Ps=800; % W
r=1e5; % m % Entfernung vom Sender
Emax_dBmuV=70; % dBmuV % max gemessene Feldstaerke
% GESUCHT: Gi, Aw

% max gemessene Feldstaerke in V/m
Emax_VDm=1e-6*10^(Emax_dBmuV/20); % log10(Power(10,x))=x
sprintf('Emax_VDm = %3.3f V/m',1e3*Emax_VDm)

% Konstanten fuer die max Sendeleistung
mu0=4*pi*1e-7; % H/m
c0=3*1e8;
eps0=1/(mu0*c0^2);
ZF0=sqrt(mu0/eps0);
Srmax=Emax_VDm^2/(2*ZF0);
sprintf('Srmax = %3.3f W/m^2',1e8*Srmax)

% Gewinn
Gi=4*pi*r^2*Srmax/Ps;
sprintf('Gi = %3.3f',Gi)
Gi_dB=10*log10(Gi);
sprintf('Gi_dB = %3.3f dBi',Gi_dB)

lambda=c0/f;
% Antennenwirkflaeche
Aw=lambda^2/(4*pi)*Gi;
sprintf('Aw = %3.3f m^2',Aw)