function [circleX, circleY]=GHF_circlePoints(winkelAnfang, winkelEnde, radius, NOP)
% Usage:    Returns a vector [circleX, circleY] with 2 points in cartesian coordinates 
%           for a circle segment with 'radius', 'NOP'-points to draw later 
%           from winkelAnfang to winkelEnde in RAD
% Example:  circlePoints(pi/2,pi,1,1000) for 
% Author:   Olexandr Lednytskyy - (05-06-2008)

% Polarcoordinates
center = [0, radius];
THETA = linspace(winkelAnfang, winkelEnde, NOP);
RHO = ones(1, NOP)*radius;
[circleX, circleY] = pol2cart(THETA, RHO);
circleX = circleX + center(2);
circleY = circleY + center(1);
