% scUndo(n=1) removes the last n figure items added before
% Usage:        GHF_plotUndo(1) to erase 1 plot-element
% Author:       Olexandr Lednytskyy - (05-06-2008)

function GHF_plotUndo(n)

if nargin==0
    n=1; 
end
if ischar(n) 
    n = sscanf(n,'%i'); 
end

if n<1 
    error(['Not undoing ' int2str(n) ' items']); 
end
g=get(gca,'children');
% L=length(g);
for i=1:n
	delete(g(i));
end
